import Diagnosis, { ExamineResult } from '../../../doctor/diagnosis';
export declare type DoctorMetaData = {
    nodeVersion: string;
    runningTimestamp: number;
    platform: string;
    bitVersion: string;
    npmVersion: string;
    yarnVersion: string;
    userDetails: string;
};
export declare type DoctorRunAllResults = {
    examineResults: ExamineResult[];
    savedFilePath: string | null | undefined;
    metaData: DoctorMetaData;
};
export declare type DoctorRunOneResult = {
    examineResult: ExamineResult;
    savedFilePath: string | null | undefined;
    metaData: DoctorMetaData;
};
declare const _default: ({ filePath }: {
    filePath?: string | undefined;
}) => Promise<DoctorRunAllResults>;
export default _default;
export declare function runOne({ diagnosisName, filePath, }: {
    diagnosisName: string;
    filePath?: string;
}): Promise<DoctorRunOneResult>;
export declare function listDiagnoses(): Promise<Diagnosis[]>;
