"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.snapAction = snapAction;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _ramda() {
  const data = _interopRequireDefault(require("ramda"));

  _ramda = function () {
    return data;
  };

  return data;
}

function _bitId() {
  const data = require("../../../bit-id");

  _bitId = function () {
    return data;
  };

  return data;
}

function _consumer() {
  const data = require("../../../consumer");

  _consumer = function () {
    return data;
  };

  return data;
}

function _componentsList() {
  const data = _interopRequireDefault(require("../../../consumer/component/components-list"));

  _componentsList = function () {
    return data;
  };

  return data;
}

function _hasWildcard() {
  const data = _interopRequireDefault(require("../../../utils/string/has-wildcard"));

  _hasWildcard = function () {
    return data;
  };

  return data;
}

function snapAction(_x) {
  return _snapAction.apply(this, arguments);
}

function _snapAction() {
  _snapAction = (0, _bluebird().coroutine)(function* (args) {
    const {
      id,
      message,
      force,
      verbose,
      ignoreUnresolvedDependencies,
      skipTests,
      skipAutoSnap
    } = args;
    const consumer = yield (0, _consumer().loadConsumer)();
    const componentsList = new (_componentsList().default)(consumer);
    const newComponents = yield componentsList.listNewComponents();
    const ids = yield getIdsToSnap();
    if (!ids) return null;
    const tagResults = yield consumer.snap({
      ids,
      ignoreUnresolvedDependencies,
      message,
      force,
      skipTests,
      verbose,
      skipAutoSnap
    }); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    tagResults.newComponents = newComponents;
    yield consumer.onDestroy(); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    return tagResults;

    function getIdsToSnap() {
      return _getIdsToSnap.apply(this, arguments);
    }

    function _getIdsToSnap() {
      _getIdsToSnap = (0, _bluebird().coroutine)(function* () {
        const idHasWildcard = id && (0, _hasWildcard().default)(id);

        if (id && !idHasWildcard) {
          const bitId = consumer.getParsedId(id);

          if (!force) {
            const componentStatus = yield consumer.getComponentStatusById(bitId); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

            if (componentStatus.modified === false) return null;
          }

          return new (_bitId().BitIds)(bitId);
        }

        const tagPendingComponents = yield componentsList.listTagPendingComponents(); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

        if (_ramda().default.isEmpty(tagPendingComponents)) return null;
        return idHasWildcard ? _componentsList().default.filterComponentsByWildcard(tagPendingComponents, id) : tagPendingComponents;
      });
      return _getIdsToSnap.apply(this, arguments);
    }
  });
  return _snapAction.apply(this, arguments);
}