import semver from 'semver';
import { BitIds } from '../../../bit-id';
import Component from '../../../consumer/component';
import { AutoTagResult } from '../../../scope/component-ops/auto-tag';
export declare type TagResults = {
    taggedComponents: Component[];
    autoTaggedResults: AutoTagResult[];
    warnings: string[];
    newComponents: BitIds;
    isSoftTag: boolean;
    publishedPackages: string[];
};
export declare const NOTHING_TO_TAG_MSG = "nothing to tag";
export declare const AUTO_TAGGED_MSG = "auto-tagged dependents";
declare type TagParams = {
    message: string;
    exactVersion: string | undefined;
    releaseType: semver.ReleaseType;
    force: boolean;
    verbose?: boolean;
    ignoreUnresolvedDependencies: boolean;
    ignoreNewestVersion: boolean;
    skipTests: boolean;
    skipAutoTag: boolean;
    persist: boolean;
    id: string;
    all: boolean;
    scope?: string;
    includeImported: boolean;
};
export declare function tagAction(tagParams: TagParams): Promise<{
    taggedComponents: Component[];
    autoTaggedResults: AutoTagResult[];
    isSoftTag: boolean;
    publishedPackages: string[];
} | null>;
export {};
