"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = put;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _ramda() {
  const data = _interopRequireDefault(require("ramda"));

  _ramda = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../../../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function _hooks() {
  const data = _interopRequireDefault(require("../../../hooks"));

  _hooks = function () {
    return data;
  };

  return data;
}

function _scope() {
  const data = require("../../../scope");

  _scope = function () {
    return data;
  };

  return data;
}

function _exportScopeComponents() {
  const data = require("../../../scope/component-ops/export-scope-components");

  _exportScopeComponents = function () {
    return data;
  };

  return data;
}

function _objectList() {
  const data = require("../../../scope/objects/object-list");

  _objectList = function () {
    return data;
  };

  return data;
}

const HooksManagerInstance = _hooks().default.getInstance();

function put(_x, _x2) {
  return _put.apply(this, arguments);
}

function _put() {
  _put = (0, _bluebird().coroutine)(function* ({
    path,
    objectList
  }, headers) {
    if (typeof objectList === 'string') {
      objectList = _objectList().ObjectList.fromJsonString(objectList);
    } // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!


    yield HooksManagerInstance.triggerHook(_constants().PRE_RECEIVE_OBJECTS, {
      path,
      objectList
    }, headers);
    const scope = yield (0, _scope().loadScope)(path);
    const componentsBitIds = yield (0, _exportScopeComponents().exportManyBareScope)(scope, objectList);
    const componentsIds = componentsBitIds.map(id => id.toString());
    let uniqComponentsIds = componentsIds;

    if (componentsIds && componentsIds.length) {
      uniqComponentsIds = _ramda().default.uniq(componentsIds);
    }

    yield HooksManagerInstance.triggerHook(_constants().POST_RECEIVE_OBJECTS, {
      objectList,
      componentsIds: uniqComponentsIds,
      scopePath: path,
      scopeName: scope.scopeJson.name
    }, // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
    headers);
    return componentsIds;
  });
  return _put.apply(this, arguments);
}