"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetResolver = exports.getResolver = exports.setResolver = void 0;

function _scope() {
  const data = require("../../../scope");

  _scope = function () {
    return data;
  };

  return data;
}

const setResolver = (currentPath, resolverPath) => {
  return (0, _scope().loadScope)(currentPath).then(scope => {
    scope.scopeJson.resolverPath = resolverPath;
    return scope.scopeJson.write(scope.getPath());
  });
};

exports.setResolver = setResolver;

const getResolver = currentPath => {
  return (0, _scope().loadScope)(currentPath).then(scope => scope.scopeJson.resolverPath);
};

exports.getResolver = getResolver;

const resetResolver = currentPath => {
  return (0, _scope().loadScope)(currentPath).then(scope => {
    scope.scopeJson.resolverPath = null;
    return scope.scopeJson.write(scope.getPath());
  });
};

exports.resetResolver = resetResolver;