import { StatusResult } from '../../../api/consumer/lib/status';
import { CommandOptions, LegacyCommand } from '../../legacy-command';
export declare const statusFailureMsg = "issues found";
export declare const statusInvalidComponentsMsg = "invalid components";
export declare const statusWorkspaceIsCleanMsg = "nothing to tag or export (use \"bit add <file...>\" to track files or directories as components)";
export declare const individualFilesDesc = "these components were added as individual files and not as directories, which are invalid in Harmony\nplease make sure each component has its own directory and re-add it. alternatively, use \"bit move --component\" to help with the move.";
export default class Status implements LegacyCommand {
    name: string;
    description: string;
    alias: string;
    opts: CommandOptions;
    loader: boolean;
    migration: boolean;
    json: boolean;
    action([]: Iterable<any>, { json }: {
        json?: boolean;
    }): Promise<Record<string, any>>;
    report({ newComponents, modifiedComponent, stagedComponents, componentsWithMissingDeps, importPendingComponents, autoTagPendingComponents, invalidComponents, outdatedComponents, mergePendingComponents, componentsDuringMergeState, componentsWithIndividualFiles, componentsWithTrackDirs, softTaggedComponents, }: StatusResult): string;
}
