import { ApplyVersionResults, MergeStrategy } from '../../../consumer/versions-ops/merge-version';
import { CommandOptions, LegacyCommand } from '../../legacy-command';
export default class Switch implements LegacyCommand {
    name: string;
    description: string;
    private: boolean;
    alias: string;
    opts: CommandOptions;
    loader: boolean;
    action([lane]: [string], { create, remote, as, merge, getAll, verbose, json, ignorePackageJson, skipNpmInstall, ignoreDist, }: {
        create?: boolean;
        remote?: string;
        as?: string;
        merge?: MergeStrategy;
        getAll?: boolean;
        verbose?: boolean;
        override?: boolean;
        json?: boolean;
        ignorePackageJson?: boolean;
        skipNpmInstall?: boolean;
        ignoreDist?: boolean;
    }): Promise<ApplyVersionResults>;
    report({ components, failedComponents, lane, create, json, }: {
        components: ApplyVersionResults['components'];
        failedComponents: ApplyVersionResults['failedComponents'];
        lane: string;
        create: boolean;
        json: boolean;
    }): string;
}
