"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.codemodTemplate = codemodTemplate;

function _chalk() {
  const data = _interopRequireDefault(require("chalk"));

  _chalk = function () {
    return data;
  };

  return data;
}

function codemodTemplate(results) {
  const reportComponents = results.map(result => {
    const files = result.changedFiles.map(file => `\t\tfile: ${_chalk().default.bold(file)}`).join('\n');
    const warnings = result.warnings ? result.warnings.map(warning => `\t\twarning: ${_chalk().default.cyan(warning)}`).join('\n') : '';
    return _chalk().default.cyan(`\t${result.id.toString()}:\n ${files} ${warnings}`);
  }).join('\n');
  const numOfCodemod = results.filter(r => r.changedFiles.length).length;

  const reportTitle = _chalk().default.underline(`rewired ${numOfCodemod} components\n`);

  const reportFooter = numOfCodemod > 0 ? _chalk().default.yellow('\nif you have a compiler set up, please run "bit build" to update the dists as well') : '';
  return reportTitle + reportComponents + reportFooter;
}