"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.sort");

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function path() {
  const data = _interopRequireWildcard(require("path"));

  path = function () {
    return data;
  };

  return data;
}

function _ramda() {
  const data = _interopRequireDefault(require("ramda"));

  _ramda = function () {
    return data;
  };

  return data;
}

function _noIdMatchWildcard() {
  const data = _interopRequireDefault(require("../../api/consumer/lib/exceptions/no-id-match-wildcard"));

  _noIdMatchWildcard = function () {
    return data;
  };

  return data;
}

function _bitId() {
  const data = require("../../bit-id");

  _bitId = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function _modelComponent() {
  const data = _interopRequireDefault(require("../../scope/models/model-component"));

  _modelComponent = function () {
    return data;
  };

  return data;
}

function _scopeRemotes() {
  const data = require("../../scope/scope-remotes");

  _scopeRemotes = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../../utils");

  _utils = function () {
    return data;
  };

  return data;
}

function _isBitIdMatchByWildcards() {
  const data = _interopRequireDefault(require("../../utils/bit/is-bit-id-match-by-wildcards"));

  _isBitIdMatchByWildcards = function () {
    return data;
  };

  return data;
}

function _component() {
  const data = _interopRequireDefault(require("../component"));

  _component = function () {
    return data;
  };

  return data;
}

class ComponentsList {
  // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
  // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
  // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
  // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
  // @ts-ignore
  constructor(consumer) {
    (0, _defineProperty2().default)(this, "consumer", void 0);
    (0, _defineProperty2().default)(this, "scope", void 0);
    (0, _defineProperty2().default)(this, "bitMap", void 0);
    (0, _defineProperty2().default)(this, "_fromFileSystem", {});
    (0, _defineProperty2().default)(this, "_fromObjectsIds", void 0);
    (0, _defineProperty2().default)(this, "_modelComponents", void 0);
    (0, _defineProperty2().default)(this, "_invalidComponents", void 0);
    (0, _defineProperty2().default)(this, "_modifiedComponents", void 0);
    (0, _defineProperty2().default)(this, "_mergePendingComponents", void 0);
    this.consumer = consumer;
    this.scope = consumer.scope;
    this.bitMap = consumer.bitMap;
  }

  getModelComponents() {
    var _this = this;

    return (0, _bluebird().coroutine)(function* () {
      if (!_this._modelComponents) {
        _this._modelComponents = yield _this.scope.listIncludeRemoteHead(_this.consumer.getCurrentLaneId());
      }

      return _this._modelComponents;
    })();
  }
  /**
   * List all bit ids stored in the model
   */


  getFromObjects() {
    var _this2 = this;

    return (0, _bluebird().coroutine)(function* () {
      if (!_this2._fromObjectsIds) {
        const modelComponents = yield _this2.getModelComponents();
        _this2._fromObjectsIds = modelComponents.map(componentObjects => {
          return new (_bitId().BitId)({
            scope: componentObjects.scope,
            name: componentObjects.name,
            version: componentObjects.scope ? componentObjects.latest() : undefined
          });
        });
      }

      return _this2._fromObjectsIds;
    })();
  }

  getAuthoredAndImportedFromFS() {
    var _this3 = this;

    return (0, _bluebird().coroutine)(function* () {
      let [authored, imported] = yield Promise.all([_this3.getFromFileSystem(_constants().COMPONENT_ORIGINS.AUTHORED), _this3.getFromFileSystem(_constants().COMPONENT_ORIGINS.IMPORTED)]);
      authored = authored || [];
      imported = imported || [];
      return authored.concat(imported);
    })();
  }
  /**
   * Components that are in the model (either, tagged from a local scope or imported), and were
   * changed in the file system
   *
   * @param {boolean} [load=false] - Whether to load the component (false will return only the id)
   * @return {Promise<string[]>}
   */


  listModifiedComponents(load = false) {
    var _this4 = this;

    return (0, _bluebird().coroutine)(function* () {
      if (!_this4._modifiedComponents) {
        const fileSystemComponents = yield _this4.getAuthoredAndImportedFromFS();

        const componentsWithUnresolvedConflicts = _this4.listDuringMergeStateComponents();

        const componentStatuses = yield _this4.consumer.getManyComponentsStatuses(fileSystemComponents.map(f => f.id));
        _this4._modifiedComponents = fileSystemComponents.filter(component => {
          const status = componentStatuses.find(s => s.id.isEqual(component.id));
          if (!status) throw new Error(`listModifiedComponents unable to find status for ${component.id.toString()}`);
          return status.status.modified;
        }).filter(component => !componentsWithUnresolvedConflicts.hasWithoutScopeAndVersion(component.id));
      }

      if (load) return _this4._modifiedComponents;
      return _this4._modifiedComponents.map(component => component.id);
    })();
  }

  listOutdatedComponents() {
    var _this5 = this;

    return (0, _bluebird().coroutine)(function* () {
      const fileSystemComponents = yield _this5.getAuthoredAndImportedFromFS();
      const componentsFromModel = yield _this5.getModelComponents();

      const componentsWithUnresolvedConflicts = _this5.listDuringMergeStateComponents();

      const mergePendingComponents = yield _this5.listMergePendingComponents();

      const mergePendingComponentsIds = _bitId().BitIds.fromArray(mergePendingComponents.map(c => c.id));

      yield Promise.all(fileSystemComponents.map( /*#__PURE__*/function () {
        var _ref = (0, _bluebird().coroutine)(function* (component) {
          const modelComponent = componentsFromModel.find(c => c.toBitId().isEqualWithoutVersion(component.id));
          if (!modelComponent || !component.id.hasVersion() || componentsWithUnresolvedConflicts.hasWithoutScopeAndVersion(component.id)) return;

          if (mergePendingComponentsIds.hasWithoutVersion(component.id)) {
            // by default, outdated include merge-pending since the remote-head and local-head are
            // different, however we want them both to be separated as they need different treatment
            return;
          }

          const latestVersionLocally = modelComponent.latest();
          const latestIncludeRemoteHead = yield modelComponent.latestIncludeRemote(_this5.scope.objects);

          const isOutdated = () => {
            if (latestIncludeRemoteHead !== latestVersionLocally) return true;
            return modelComponent.isLatestGreaterThan(component.id.version);
          };

          if (isOutdated()) {
            // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
            component.latestVersion = latestIncludeRemoteHead;
          }
        });

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }())); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      return fileSystemComponents.filter(f => f.latestVersion);
    })();
  }

  listMergePendingComponents() {
    var _this6 = this;

    return (0, _bluebird().coroutine)(function* () {
      if (!_this6._mergePendingComponents) {
        const componentsFromFs = yield _this6.getAuthoredAndImportedFromFS();
        const componentsFromModel = yield _this6.getModelComponents();

        const componentsWithUnresolvedConflicts = _this6.listDuringMergeStateComponents();

        _this6._mergePendingComponents = (yield Promise.all(componentsFromFs.map( /*#__PURE__*/function () {
          var _ref2 = (0, _bluebird().coroutine)(function* (component) {
            const modelComponent = componentsFromModel.find(c => c.toBitId().isEqualWithoutVersion(component.id));
            if (!modelComponent || componentsWithUnresolvedConflicts.hasWithoutScopeAndVersion(component.id)) return null;
            yield modelComponent.setDivergeData(_this6.scope.objects);
            const divergedData = modelComponent.getDivergeData();
            if (!modelComponent.getDivergeData().isDiverged()) return null;
            return {
              id: modelComponent.toBitId(),
              diverge: divergedData
            };
          });

          return function (_x2) {
            return _ref2.apply(this, arguments);
          };
        }()))).filter(x => x);
      }

      return _this6._mergePendingComponents;
    })();
  }

  listComponentsWithUnresolvedConflicts() {
    const unresolvedComponents = this.scope.objects.unmergedComponents.getUnresolvedComponents();
    return _bitId().BitIds.fromArray(unresolvedComponents.map(u => new (_bitId().BitId)(u.id)));
  }

  listDuringMergeStateComponents() {
    const unresolvedComponents = this.scope.objects.unmergedComponents.getComponents();
    return _bitId().BitIds.fromArray(unresolvedComponents.map(u => new (_bitId().BitId)(u.id)));
  }

  listSoftTaggedComponents() {
    return this.bitMap.components.filter(c => c.nextVersion).map(c => c.id);
  }

  newModifiedAndAutoTaggedComponents() {
    var _this7 = this;

    return (0, _bluebird().coroutine)(function* () {
      const [newComponents, modifiedComponents] = yield Promise.all([_this7.listNewComponents(true), _this7.listModifiedComponents(true)]);
      const autoTagPending = yield _this7.listAutoTagPendingComponents(); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      const components = [...newComponents, ...modifiedComponents, ...autoTagPending];
      return Promise.all(components);
    })();
  }

  authoredAndImportedComponents() {
    var _this8 = this;

    return (0, _bluebird().coroutine)(function* () {
      return _this8.getAuthoredAndImportedFromFS();
    })();
  }

  idsFromObjects() {
    var _this9 = this;

    return (0, _bluebird().coroutine)(function* () {
      const fromObjects = yield _this9.getFromObjects(); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      return new (_bitId().BitIds)(...fromObjects);
    })();
  }
  /**
   * Components that are registered in bit.map but have never been tagged
   *
   * @param {boolean} [load=false] - Whether to load the component (false will return only the id)
   * @return {Promise.<string[] | Component[]>}
   * @memberof ComponentsList
   */


  listNewComponents(load = false) {
    var _this10 = this;

    return (0, _bluebird().coroutine)(function* () {
      const idsFromBitMap = _this10.idsFromBitMap();

      const idsFromObjects = yield _this10.idsFromObjects();
      const newComponents = [];
      idsFromBitMap.forEach(id => {
        if (!idsFromObjects.searchWithoutVersion(id)) {
          newComponents.push(id);
        }
      }); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      const newComponentsIds = new (_bitId().BitIds)(...newComponents);
      if (!load || !newComponents.length) return newComponentsIds;
      const {
        components
      } = yield _this10.consumer.loadComponents(newComponentsIds, false);
      return components;
    })();
  }

  listTagPendingOfAllScope(includeImported = false) {
    var _this11 = this;

    return (0, _bluebird().coroutine)(function* () {
      const tagPendingComponents = _this11.idsFromBitMap(_constants().COMPONENT_ORIGINS.AUTHORED);

      if (includeImported) {
        const importedComponents = _this11.idsFromBitMap(_constants().COMPONENT_ORIGINS.IMPORTED);

        tagPendingComponents.push(...importedComponents);
      }

      return tagPendingComponents;
    })();
  }
  /**
   * New and modified components are tag pending
   *
   * @return {Promise<string[]>}
   */


  listTagPendingComponents() {
    var _this12 = this;

    return (0, _bluebird().coroutine)(function* () {
      const [newComponents, modifiedComponents] = yield Promise.all([_this12.listNewComponents(), _this12.listModifiedComponents()]); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      return _bitId().BitIds.fromArray([...newComponents, ...modifiedComponents]);
    })();
  }

  listExportPendingComponentsIds(lane) {
    var _this13 = this;

    return (0, _bluebird().coroutine)(function* () {
      const modelComponents = yield _this13.getModelComponents();
      const pendingExportComponents = yield (0, _utils().filterAsync)(modelComponents, component => component.isLocallyChanged(lane, _this13.scope.objects));

      const ids = _bitId().BitIds.fromArray(pendingExportComponents.map(c => c.toBitId()));

      return _this13.updateIdsFromModelIfTheyOutOfSync(ids);
    })();
  }

  listNonNewComponentsIds() {
    var _this14 = this;

    return (0, _bluebird().coroutine)(function* () {
      const authoredAndImported = yield _this14.getAuthoredAndImportedFromFS(); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      const newComponents = yield _this14.listNewComponents();
      const nonNewComponents = authoredAndImported.filter(component => !newComponents.has(component.id));
      return _bitId().BitIds.fromArray(nonNewComponents.map(c => c.id.changeVersion(undefined)));
    })();
  }

  updateIdsFromModelIfTheyOutOfSync(ids) {
    var _this15 = this;

    return (0, _bluebird().coroutine)(function* () {
      const authoredAndImported = _this15.bitMap.getAuthoredAndImportedBitIds();

      const updatedIdsP = ids.map( /*#__PURE__*/function () {
        var _ref3 = (0, _bluebird().coroutine)(function* (id) {
          const idFromBitMap = authoredAndImported.searchWithoutScopeAndVersion(id);

          if (idFromBitMap && !idFromBitMap.hasVersion()) {
            // component is out of sync, fix it by loading it from the consumer
            const component = yield _this15.consumer.loadComponent(id.changeVersion(_constants().LATEST));
            return component.id;
          }

          return id;
        });

        return function (_x3) {
          return _ref3.apply(this, arguments);
        };
      }());
      const updatedIds = yield Promise.all(updatedIdsP);
      return _bitId().BitIds.fromArray(updatedIds);
    })();
  }

  listExportPendingComponents(laneObj) {
    var _this16 = this;

    return (0, _bluebird().coroutine)(function* () {
      const exportPendingComponentsIds = yield _this16.listExportPendingComponentsIds(laneObj); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      return Promise.all(exportPendingComponentsIds.map(id => _this16.scope.getModelComponentIfExist(id)));
    })();
  }

  listAutoTagPendingComponents() {
    var _this17 = this;

    return (0, _bluebird().coroutine)(function* () {
      const modifiedComponents = yield _this17.listModifiedComponents();
      if (!modifiedComponents || !modifiedComponents.length) return [];
      return _this17.consumer.listComponentsForAutoTagging(_bitId().BitIds.fromArray(modifiedComponents));
    })();
  }

  idsFromBitMap(origin) {
    const fromBitMap = this.getFromBitMap(origin);
    return fromBitMap;
  }

  listAllIdsFromWorkspaceAndScope() {
    var _this18 = this;

    return (0, _bluebird().coroutine)(function* () {
      const idsFromBitMap = _this18.idsFromBitMap();

      const idsFromObjects = yield _this18.idsFromObjects();
      return _bitId().BitIds.uniqFromArray([...idsFromBitMap, ...idsFromObjects]);
    })();
  }
  /**
   * Finds all components that are saved in the file system.
   * Components might be stored in the default component directory and also might be outside
   * of that directory. The bit.map is used to find them all
   * If they are on bit.map but not on the file-system, populate them to _invalidComponents property
   */


  getFromFileSystem(origin) {
    var _this19 = this;

    return (0, _bluebird().coroutine)(function* () {
      const cacheKeyName = origin || 'all';

      if (!_this19._fromFileSystem[cacheKeyName]) {
        const idsFromBitMap = _this19.idsFromBitMap(origin); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!


        const {
          components,
          invalidComponents
        } = yield _this19.consumer.loadComponents(idsFromBitMap, false);
        _this19._fromFileSystem[cacheKeyName] = components;

        if (!_this19._invalidComponents && !origin) {
          _this19._invalidComponents = invalidComponents;
        }
      }

      return _this19._fromFileSystem[cacheKeyName];
    })();
  }
  /**
   * components that are on bit.map but not on the file-system
   */


  listInvalidComponents() {
    var _this20 = this;

    return (0, _bluebird().coroutine)(function* () {
      if (!_this20._invalidComponents) {
        yield _this20.getFromFileSystem();
      }

      return _this20._invalidComponents;
    })();
  }
  /**
   * valid on legacy only. Harmony requires components to have their own directories
   */


  listComponentsWithIndividualFiles() {
    var _this21 = this;

    return (0, _bluebird().coroutine)(function* () {
      if (_this21.consumer.isLegacy) return [];
      const workspaceComponents = yield _this21.getFromFileSystem(_constants().COMPONENT_ORIGINS.AUTHORED);
      return workspaceComponents.filter(component => {
        const componentMap = component.componentMap;
        if (!componentMap) throw new Error('listComponentsWithIndividualFiles componentMap is missing');
        return Boolean(!componentMap.trackDir && !componentMap.rootDir);
      });
    })();
  }
  /**
   * valid on legacy only. Harmony creates `rootDir` instead of the `trackDir`.
   */


  listComponentsWithTrackDir() {
    var _this22 = this;

    return (0, _bluebird().coroutine)(function* () {
      if (_this22.consumer.isLegacy) return [];
      const workspaceComponents = yield _this22.getFromFileSystem(_constants().COMPONENT_ORIGINS.AUTHORED);
      return workspaceComponents.filter(component => {
        const componentMap = component.componentMap;
        if (!componentMap) throw new Error('listComponentsWithIndividualFiles componentMap is missing');
        return Boolean(componentMap.trackDir);
      });
    })();
  }

  getFromBitMap(origin) {
    const originParam = origin ? [origin] : undefined;
    return this.bitMap.getAllIdsAvailableOnLane(originParam);
  }

  getPathsForAllFilesOfAllComponents(origin, absolute = false) {
    // TODO: maybe cache this as well
    const componentMaps = this.bitMap.getAllComponents(origin);
    const result = [];

    const populatePaths = componentMap => {
      const relativePaths = componentMap.getFilesRelativeToConsumer();

      if (!absolute) {
        result.push(...relativePaths);
        return;
      }

      const consumerPath = this.consumer.getPath();
      const absPaths = relativePaths.map(relativePath => path().join(consumerPath, relativePath));
      result.push(...absPaths);
    };

    componentMaps.forEach(componentMap => populatePaths(componentMap));
    return result;
  }
  /**
   * get called when the Consumer is available, shows also components from remote scopes
   */


  listScope(showRemoteVersion, includeNested, namespacesUsingWildcards) {
    var _this23 = this;

    return (0, _bluebird().coroutine)(function* () {
      const components = yield _this23.getModelComponents();
      const componentsFilteredByWildcards = namespacesUsingWildcards ? ComponentsList.filterComponentsByWildcard(components, namespacesUsingWildcards) : components;
      const componentsSorted = ComponentsList.sortComponentsByName(componentsFilteredByWildcards);
      const listScopeResults = componentsSorted.map(component => ({
        id: component.toBitIdWithLatestVersion(),
        deprecated: component.deprecated
      }));
      const componentsIds = listScopeResults.map(result => result.id);

      if (showRemoteVersion) {
        const latestVersionsInfo = yield (0, _scopeRemotes().fetchRemoteVersions)(_this23.scope, componentsIds);
        latestVersionsInfo.forEach(componentId => {
          const listResult = listScopeResults.find(c => c.id.isEqualWithoutVersion(componentId));
          if (!listResult) throw new Error(`failed finding ${componentId.toString()} in componentsIds`); // $FlowFixMe version must be set as it came from a remote
          // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

          listResult.remoteVersion = componentId.version;
        });
      }

      const authoredAndImportedIds = _this23.bitMap.getAuthoredAndImportedBitIds();

      listScopeResults.forEach(listResult => {
        const existingBitMapId = authoredAndImportedIds.searchWithoutVersion(listResult.id);

        if (existingBitMapId) {
          listResult.currentlyUsedVersion = existingBitMapId.version;
        }
      });
      if (includeNested) return listScopeResults;
      const currentLane = yield _this23.consumer.getCurrentLaneObject();

      const isIdOnCurrentLane = componentMap => {
        if (!componentMap.onLanesOnly) return true; // component is on master, always show it

        if (!currentLane) return false; // if !currentLane the user is on master, don't show it.

        return Boolean(currentLane.getComponent(componentMap.id));
      };

      return listScopeResults.filter(listResult => {
        const componentMap = _this23.bitMap.getComponentIfExist(listResult.id, {
          ignoreVersion: true
        });

        return componentMap && componentMap.origin !== _constants().COMPONENT_ORIGINS.NESTED && isIdOnCurrentLane(componentMap);
      });
    })();
  }
  /**
   * get called from a bare-scope, shows only components of that scope
   */


  static listLocalScope(scope, namespacesUsingWildcards) {
    return (0, _bluebird().coroutine)(function* () {
      const components = yield scope.listLocal();
      const componentsFilteredByWildcards = namespacesUsingWildcards ? ComponentsList.filterComponentsByWildcard(components, namespacesUsingWildcards) : components;
      const componentsSorted = ComponentsList.sortComponentsByName(componentsFilteredByWildcards);
      return componentsSorted.map(component => ({
        id: component.toBitIdWithLatestVersion(),
        deprecated: component.deprecated
      }));
    })();
  } // components can be one of the following: Component[] | ModelComponent[] | string[] | BitId[]


  static sortComponentsByName(components) {
    const getName = component => {
      let name;
      if (_ramda().default.is(_modelComponent().default, component)) name = component.id();else if (_ramda().default.is(_component().default, component)) name = component.id.toString();else if (_ramda().default.is(_bitId().BitId, component)) name = component.toString();else name = component;
      return name.toUpperCase(); // ignore upper and lowercase
    }; // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!


    return components.sort((a, b) => {
      const nameA = getName(a);
      const nameB = getName(b);

      if (nameA < nameB) {
        return -1;
      }

      if (nameA > nameB) {
        return 1;
      } // names must be equal


      return 0;
    });
  }

  static filterComponentsByWildcard(components, idsWithWildcard) {
    const getBitId = component => {
      if (_ramda().default.is(_modelComponent().default, component)) return component.toBitId();
      if (_ramda().default.is(_component().default, component)) return component.id;
      if (_ramda().default.is(_bitId().BitId, component)) return component;
      throw new TypeError(`filterComponentsByWildcard got component with the wrong type: ${typeof component}`);
    }; // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!


    return components.filter(component => {
      const bitId = getBitId(component);
      return (0, _isBitIdMatchByWildcards().default)(bitId, idsWithWildcard);
    });
  }

  static getUniqueComponents(components) {
    return _ramda().default.uniqBy(component => JSON.stringify(component.id), components);
  }

  listComponentsByIdsWithWildcard(idsWithWildcard) {
    const allIds = this.bitMap.getAuthoredAndImportedBitIds();
    const matchedIds = ComponentsList.filterComponentsByWildcard(allIds, idsWithWildcard);
    if (!matchedIds.length) throw new (_noIdMatchWildcard().default)(idsWithWildcard); // $FlowFixMe filterComponentsByWildcard got BitId so it returns BitId

    return matchedIds;
  }

}

exports.default = ComponentsList;