"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PackageJsonTransformer = void 0;

function _bluebird() {
  const data = _interopRequireWildcard(require("bluebird"));

  _bluebird = function () {
    return data;
  };

  return data;
}

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _componentPlaceholders() {
  const data = require("../../utils/bit/component-placeholders");

  _componentPlaceholders = function () {
    return data;
  };

  return data;
}

class PackageJsonTransformer {
  static registerPackageJsonTransformer(func) {
    this.packageJsonTransformersRegistry.push(func);
  }
  /**
   * these are changes made by aspects
   */


  static applyTransformers(component, packageJson) {
    return (0, _bluebird().coroutine)(function* () {
      let newPackageJsonObject = packageJson.packageJsonObject;
      yield _bluebird().default.mapSeries(PackageJsonTransformer.packageJsonTransformersRegistry, /*#__PURE__*/function () {
        var _ref = (0, _bluebird().coroutine)(function* (transformer) {
          newPackageJsonObject = yield transformer(component, newPackageJsonObject);
        });

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
      Object.keys(newPackageJsonObject).forEach(key => {
        const value = (0, _componentPlaceholders().replacePlaceHolderWithComponentValue)(component, newPackageJsonObject[key]);
        newPackageJsonObject[key] = value;
      }, {});
      packageJson.mergePackageJsonObject(newPackageJsonObject);
    })();
  }

}

exports.PackageJsonTransformer = PackageJsonTransformer;
(0, _defineProperty2().default)(PackageJsonTransformer, "packageJsonTransformersRegistry", []);