import { BitId, BitIds } from '../../bit-id';
declare type ConfigOnlyEntry = {
    id: string;
    config: Record<string, any>;
};
export declare class ExtensionDataEntry {
    legacyId?: string | undefined;
    extensionId?: BitId | undefined;
    name?: string | undefined;
    config: {
        [key: string]: any;
    };
    data: {
        [key: string]: any;
    };
    newExtensionId: any;
    constructor(legacyId?: string | undefined, extensionId?: BitId | undefined, name?: string | undefined, config?: {
        [key: string]: any;
    }, data?: {
        [key: string]: any;
    }, newExtensionId?: any);
    get id(): string | BitId;
    get stringId(): string;
    get isLegacy(): boolean;
    clone(): ExtensionDataEntry;
}
export declare class ExtensionDataList extends Array<ExtensionDataEntry> {
    static coreExtensionsNames: Map<string, string>;
    static registerCoreExtensionName(name: string): void;
    static registerManyCoreExtensionNames(names: string[]): void;
    get ids(): string[];
    get extensionsBitIds(): BitIds;
    toModelObjects(): ExtensionDataList;
    static fromModelObject(entries: ExtensionDataEntry[]): ExtensionDataList;
    findExtension(extensionId: string, ignoreVersion?: boolean, ignoreScope?: boolean): ExtensionDataEntry | undefined;
    findCoreExtension(extensionId: string): ExtensionDataEntry | undefined;
    remove(id: BitId): ExtensionDataList;
    toConfigObject(): {};
    toConfigArray(): ConfigOnlyEntry[];
    clone(): ExtensionDataList;
    _filterLegacy(): ExtensionDataList;
    sortById(): ExtensionDataList;
    static fromConfigObject(obj: {
        [extensionId: string]: any;
    }): ExtensionDataList;
    static fromArray(entries: ExtensionDataEntry[]): ExtensionDataList;
    static mergeConfigs(list: ExtensionDataList[]): ExtensionDataList;
}
export {};
