import CommandHelper from './e2e-command-helper';
import FsHelper from './e2e-fs-helper';
import NpmHelper from './e2e-npm-helper';
import PackageJsonHelper from './e2e-package-json-helper';
import ScopeHelper from './e2e-scope-helper';
import ScopesData from './e2e-scopes';
export default class FixtureHelper {
    fs: FsHelper;
    command: CommandHelper;
    scopes: ScopesData;
    debugMode: boolean;
    npm: NpmHelper;
    packageJson: PackageJsonHelper;
    scopeHelper: ScopeHelper;
    constructor(fsHelper: FsHelper, commandHelper: CommandHelper, npmHelper: NpmHelper, scopes: ScopesData, debugMode: boolean, packageJson: PackageJsonHelper, scopeHelper: ScopeHelper);
    createComponentBarFoo(impl?: string): void;
    createComponentUtilsIsType(impl?: string): void;
    createComponentUtilsIsString(impl?: string): void;
    addComponentBarFoo(): string;
    addComponentBarFooAsDir(): string;
    addComponentUtilsIsType(): string;
    addComponentUtilsIsString(): string;
    tagComponentBarFoo(): string;
    getFixturesDir(): string;
    copyFixtureDir(src: string, dest: string): void;
    copyFixtureComponents(dir?: string, cwd?: string): void;
    copyFixtureExtensions(dir?: string, cwd?: string): void;
    copyFixtureFile(pathToFile?: string, newName?: string, cwd?: string): void;
    populateWorkspaceWithThreeComponents(): void;
    populateWorkspaceWithComponentsWithV2(): void;
    populateWorkspaceWithThreeComponentsAndModulePath(useDefaultScope?: boolean): void;
    populateWorkspaceWithComponents(): void;
    populateComponents(numOfComponents?: number): string;
    populateExtensions(numOfExtensions?: number): void;
    populateComponentsTS(numOfComponents?: number, owner?: string, isHarmony?: boolean): string;
    populateWorkspaceWithTwoComponents(): void;
    populateWorkspaceWithUtilsIsType(): void;
    populateWorkspaceWithComponentsAndPackages(): void;
    addExtensionTS(): void;
    ensureGlobalRemoteScope(): void;
}
