import { InteractiveInputs } from '../interactive/utils/run-interactive-cmd';
import CommandHelper from './e2e-command-helper';
import FsHelper from './e2e-fs-helper';
import NpmHelper from './e2e-npm-helper';
import ScopesData from './e2e-scopes';
export default class ScopeHelper {
    debugMode: boolean;
    scopes: ScopesData;
    e2eDir: string;
    command: CommandHelper;
    fs: FsHelper;
    npm: NpmHelper;
    cache: Record<string, any>;
    keepEnvs: boolean;
    clonedScopes: string[];
    packageManager: string;
    constructor(debugMode: boolean, scopes: ScopesData, commandHelper: CommandHelper, fsHelper: FsHelper, npmHelper: NpmHelper);
    clean(): void;
    destroy(): void;
    cleanLocalScope(): void;
    usePackageManager(packageManager: string): void;
    reInitLocalScope(): void;
    reInitLocalScopeHarmony(): void;
    initHarmonyWorkspace(): void;
    reInitLocalWorkspaceHarmonyForNewAspects(): void;
    initLocalScope(): string;
    initWorkspace(workspacePath?: string): string;
    initWorkspaceAndRemoteScope(workspacePath?: string): void;
    initInteractive(inputs: InteractiveInputs): Promise<any>;
    initLocalScopeWithOptions(options: Record<string, any>): string;
    setNewLocalAndRemoteScopes(): void;
    setNewLocalAndRemoteScopesHarmony(): void;
    initNewLocalScope(deleteCurrentScope?: boolean): string;
    addRemoteScope(remoteScopePath?: string, localScopePath?: string, isGlobal?: boolean): string;
    addRemoteHttpScope(): string;
    removeRemoteScope(remoteScope?: string, isGlobal?: boolean): string;
    addRemoteEnvironment(isGlobal?: boolean): string;
    addGlobalRemoteScope(): string;
    removeRemoteEnvironment(isGlobal?: boolean): string;
    reInitRemoteScope(scopePath?: string): string;
    setRemoteScopeAsDifferentDir(): void;
    reInitEnvsScope(): string;
    getNewBareScope(scopeNameSuffix?: string | undefined): {
        scopeName: string;
        scopePath: string;
    };
    cloneLocalScope(dereferenceSymlinks?: boolean): string;
    getClonedLocalScope(clonedScopePath: string, deleteCurrentScope?: boolean): void;
    cloneRemoteScope(): string;
    cloneScope(scopePath: string): string;
    getClonedScope(clonedScopePath: string, scopePath: string): void;
    getClonedRemoteScope(clonedScopePath: string): void;
    switchFromLegacyToHarmony(): void;
    linkBitBin(): void;
    linkCoreAspects(): void;
}
