import winston, { LogEntry, Logger } from 'winston';
export interface IBitLogger {
    silly(message: string, ...meta: any[]): void;
    debug(message: string, ...meta: any[]): void;
    warn(message: string, ...meta: any[]): void;
    info(message: string, ...meta: any[]): void;
    error(message: string, ...meta: any[]): void;
    console(msg: string): void;
}
export declare const baseFileTransportOpts: {
    filename: string;
    format: winston.Logform.Format;
    level: string;
    maxsize: number;
    maxFiles: number;
    tailable: boolean;
};
export declare function getFormat(): winston.Logform.Format;
declare class BitLogger implements IBitLogger {
    logger: Logger;
    shouldWriteToConsole: boolean;
    constructor(logger: Logger);
    silly(message: string, ...meta: any[]): void;
    debug(message: string, ...meta: any[]): void;
    warn(message: string, ...meta: any[]): void;
    info(message: string, ...meta: any[]): void;
    error(message: string, ...meta: any[]): void;
    console(msg?: string | Error, level?: string, color?: string): void;
    profile(id: string, meta?: LogEntry): void;
    exitAfterFlush(code: number | undefined, commandName: string): Promise<void>;
    debugAndAddBreadCrumb(category: string, message: string, data?: Record<string, any>, extraData?: Record<string, any>): void;
    warnAndAddBreadCrumb(category: string, message: string, data?: Record<string, any>, extraData?: Record<string, any>): void;
    errorAndAddBreadCrumb(category: string, message: string, data?: Record<string, any>, extraData?: Record<string, any>): void;
    private addToLoggerAndToBreadCrumb;
}
declare const logger: BitLogger;
export declare const createExtensionLogger: (extensionName: string) => any;
export declare const printWarning: (msg: string) => void;
export declare function writeLogToScreen(levelOrPrefix?: string): void;
export default logger;
