/// <reference types="node" />
import ModelComponent from './models/model-component';
import BitObject from './objects/object';
export default class ComponentObjects {
    component: Buffer;
    objects: Buffer[];
    constructor(component: Buffer, objects: Buffer[]);
    toString(): string;
    getParsedComponent(): BitObject;
    static fromString(str: string): ComponentObjects;
    static manyToString(componentsAndObjects: Array<{
        component: Buffer;
        objects: Buffer[];
    }>): string;
    static manyFromString(str: string): ComponentObjects[];
    static fromObject(object: Record<string, any>): ComponentObjects;
    toObjects(): {
        component: ModelComponent;
        objects: BitObject[];
    };
    toObjectsAsync(): Promise<{
        component: ModelComponent;
        objects: BitObject[];
    }>;
}
