import { ReleaseType } from 'semver';
import { Scope } from '..';
import Component from '../../consumer/component/consumer-component';
import Consumer from '../../consumer/consumer';
import { AutoTagResult } from './auto-tag';
export default function tagModelComponent({ consumerComponents, scope, message, exactVersion, releaseType, force, consumer, ignoreNewestVersion, skipTests, verbose, skipAutoTag, persist, resolveUnmerged, isSnap, }: {
    consumerComponents: Component[];
    scope: Scope;
    message: string;
    exactVersion?: string | null | undefined;
    releaseType?: ReleaseType;
    force: boolean | null | undefined;
    consumer: Consumer;
    ignoreNewestVersion?: boolean;
    skipTests: boolean;
    verbose?: boolean;
    skipAutoTag: boolean;
    persist: boolean;
    resolveUnmerged?: boolean;
    isSnap?: boolean;
}): Promise<{
    taggedComponents: Component[];
    autoTaggedResults: AutoTagResult[];
    publishedPackages: string[];
}>;
