"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.promise");

require("core-js/modules/es.string.replace");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = tagModelComponent;

function _bluebird() {
  const data = _interopRequireWildcard(require("bluebird"));

  _bluebird = function () {
    return data;
  };

  return data;
}

function _ramda() {
  const data = _interopRequireDefault(require("ramda"));

  _ramda = function () {
    return data;
  };

  return data;
}

function RA() {
  const data = _interopRequireWildcard(require("ramda-adjunct"));

  RA = function () {
    return data;
  };

  return data;
}

function _uuid() {
  const data = require("uuid");

  _uuid = function () {
    return data;
  };

  return data;
}

function globalConfig() {
  const data = _interopRequireWildcard(require("../../api/consumer/lib/global-config"));

  globalConfig = function () {
    return data;
  };

  return data;
}

function _bitId() {
  const data = require("../../bit-id");

  _bitId = function () {
    return data;
  };

  return data;
}

function _loader() {
  const data = _interopRequireDefault(require("../../cli/loader"));

  _loader = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function _componentSchema() {
  const data = require("../../consumer/component/component-schema");

  _componentSchema = function () {
    return data;
  };

  return data;
}

function _exceptions() {
  const data = require("../../consumer/exceptions");

  _exceptions = function () {
    return data;
  };

  return data;
}

function _generalError() {
  const data = _interopRequireDefault(require("../../error/general-error"));

  _generalError = function () {
    return data;
  };

  return data;
}

function _showDoctorError() {
  const data = _interopRequireDefault(require("../../error/show-doctor-error"));

  _showDoctorError = function () {
    return data;
  };

  return data;
}

function _validationError() {
  const data = _interopRequireDefault(require("../../error/validation-error"));

  _validationError = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = _interopRequireDefault(require("../../logger/logger"));

  _logger = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../../utils");

  _utils = function () {
    return data;
  };

  return data;
}

function _autoTag() {
  const data = require("./auto-tag");

  _autoTag = function () {
    return data;
  };

  return data;
}

function _getFlattenedDependencies() {
  const data = require("./get-flattened-dependencies");

  _getFlattenedDependencies = function () {
    return data;
  };

  return data;
}

function _semverHelper() {
  const data = require("../../utils/semver-helper");

  _semverHelper = function () {
    return data;
  };

  return data;
}

function updateDependenciesVersions(componentsToTag) {
  const getNewDependencyVersion = id => {
    const foundDependency = componentsToTag.find(component => component.id.isEqualWithoutVersion(id));
    return foundDependency ? id.changeVersion(foundDependency.version) : null;
  };

  componentsToTag.forEach(oneComponentToTag => {
    oneComponentToTag.getAllDependencies().forEach(dependency => {
      const newDepId = getNewDependencyVersion(dependency.id);
      if (newDepId) dependency.id = newDepId;
    }); // TODO: in case there are core extensions they should be excluded here

    oneComponentToTag.extensions.forEach(extension => {
      if (extension.name === _constants().Extensions.dependencyResolver && extension.data && extension.data.dependencies) {
        extension.data.dependencies.forEach(dep => {
          const depId = dep.componentId instanceof _bitId().BitId ? dep.componentId : new (_bitId().BitId)(dep.componentId);
          const newDepId = getNewDependencyVersion(depId);
          dep.componentId = newDepId || depId;
        });
      } // For core extensions there won't be an extensionId but name
      // We only want to add version to external extensions not core extensions


      if (!extension.extensionId) return;
      const newDepId = getNewDependencyVersion(extension.extensionId);
      if (newDepId) extension.extensionId = newDepId;else if (!extension.extensionId.hasScope() && !extension.extensionId.hasVersion()) {
        throw new (_generalError().default)(`fatal: "${oneComponentToTag.id.toString()}" has an extension "${extension.extensionId.toString()}".
this extension was not included in the tag command.`);
      }
    });
  });
}

function setHashes(componentsToTag) {
  componentsToTag.forEach(componentToTag => {
    componentToTag.version = (0, _utils().sha1)((0, _uuid().v4)());
  });
}

function setFutureVersions(_x, _x2, _x3, _x4, _x5) {
  return _setFutureVersions.apply(this, arguments);
}
/**
 * make sure the originallySharedDir was added before saving the component. also, make sure it was
 * not added twice.
 * we need three objects for this:
 * 1) component.pendingVersion => version pending to be saved in the filesystem. we want to make sure it has the added sharedDir.
 * 2) component.componentFromModel => previous version of the component. it has the original sharedDir.
 * 3) component.componentMap => current paths in the filesystem, which don't have the sharedDir.
 *
 * The component may be changed from the componentFromModel. The files may be removed and added and
 * new files may added, so we can't compare the files of componentFromModel to component.
 *
 * What we can do is calculating the sharedDir from component.componentFromModel
 * then, make sure that calculatedSharedDir + pathFromComponentMap === component.pendingVersion
 *
 * Also, make sure that the wrapDir has been removed
 */


function _setFutureVersions() {
  _setFutureVersions = (0, _bluebird().coroutine)(function* (componentsToTag, scope, releaseType, exactVersion, persist) {
    yield Promise.all(componentsToTag.map( /*#__PURE__*/function () {
      var _ref = (0, _bluebird().coroutine)(function* (componentToTag) {
        var _componentToTag$compo, _componentToTag$compo2;

        // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
        const modelComponent = yield scope.sources.findOrAddComponent(componentToTag);
        const nextVersion = (_componentToTag$compo = componentToTag.componentMap) === null || _componentToTag$compo === void 0 ? void 0 : (_componentToTag$compo2 = _componentToTag$compo.nextVersion) === null || _componentToTag$compo2 === void 0 ? void 0 : _componentToTag$compo2.version;

        if (nextVersion && persist) {
          const exactVersionOrReleaseType = (0, _semverHelper().getValidVersionOrReleaseType)(nextVersion);
          if (exactVersionOrReleaseType.exactVersion) exactVersion = exactVersionOrReleaseType.exactVersion;
          if (exactVersionOrReleaseType.releaseType) releaseType = exactVersionOrReleaseType.releaseType;
        }

        const version = modelComponent.getVersionToAdd(releaseType, exactVersion); // @ts-ignore usedVersion is needed only for this, that's why it's not declared on the instance

        componentToTag.usedVersion = componentToTag.version;
        componentToTag.version = version;
      });

      return function (_x16) {
        return _ref.apply(this, arguments);
      };
    }()));
  });
  return _setFutureVersions.apply(this, arguments);
}

function validateDirManipulation(components) {
  const throwOnError = (expectedPath, actualPath) => {
    if (expectedPath !== actualPath) {
      throw new (_validationError().default)(`failed validating the component paths with sharedDir, expected path ${expectedPath}, got ${actualPath}`);
    }
  };

  const validateComponent = component => {
    if (!component.componentMap) throw new Error(`componentMap is missing from ${component.id.toString()}`);
    if (!component.componentFromModel) return; // component.componentFromModel.setOriginallySharedDir();

    const sharedDir = component.componentFromModel.originallySharedDir;
    const wrapDir = component.componentFromModel.wrapDir;

    const pathWithSharedDir = pathStr => {
      // $FlowFixMe componentMap is set here
      // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
      if (sharedDir && component.componentMap.origin === _constants().COMPONENT_ORIGINS.IMPORTED) {
        return (0, _utils().pathJoinLinux)(sharedDir, pathStr);
      }

      return pathStr;
    };

    const pathWithoutWrapDir = pathStr => {
      if (wrapDir) {
        return pathStr.replace(`${wrapDir}/`, '');
      }

      return pathStr;
    };

    const pathAfterDirManipulation = pathStr => {
      const withoutWrapDir = pathWithoutWrapDir(pathStr);
      return pathWithSharedDir(withoutWrapDir);
    };

    const expectedMainFile = pathAfterDirManipulation(component.componentMap.mainFile); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    throwOnError(expectedMainFile, component.pendingVersion.mainFile); // $FlowFixMe componentMap is set here

    const componentMapFiles = component.componentMap.getAllFilesPaths(); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    const componentFiles = component.pendingVersion.files.map(file => file.relativePath);
    componentMapFiles.forEach(file => {
      const expectedFile = pathAfterDirManipulation(file);

      if (!componentFiles.includes(expectedFile)) {
        throw new (_validationError().default)(`failed validating the component paths, expected a file ${expectedFile} to be in ${componentFiles.toString()} array`);
      }
    });
  };

  components.forEach(component => validateComponent(component));
}

function tagModelComponent(_x6) {
  return _tagModelComponent.apply(this, arguments);
}

function _tagModelComponent() {
  _tagModelComponent = (0, _bluebird().coroutine)(function* ({
    consumerComponents,
    scope,
    message,
    exactVersion,
    releaseType,
    force,
    consumer,
    ignoreNewestVersion = false,
    skipTests = false,
    verbose = false,
    skipAutoTag,
    persist,
    resolveUnmerged,
    isSnap = false
  }) {
    if (!persist) skipTests = true;
    const consumerComponentsIdsMap = {}; // Concat and unique all the dependencies from all the components so we will not import
    // the same dependency more then once, it's mainly for performance purpose

    consumerComponents.forEach(consumerComponent => {
      const componentIdString = consumerComponent.id.toString(); // Store it in a map so we can take it easily from the sorted array which contain only the id

      consumerComponentsIdsMap[componentIdString] = consumerComponent;
    });

    const componentsToTag = _ramda().default.values(consumerComponentsIdsMap); // consumerComponents unique


    const idsToTriggerAutoTag = componentsToTag.map(c => c.id).filter(id => id.hasVersion());
    const autoTagData = skipAutoTag ? [] : yield (0, _autoTag().getAutoTagInfo)(consumer, _bitId().BitIds.fromArray(idsToTriggerAutoTag));
    const autoTagConsumerComponents = autoTagData.map(autoTagItem => autoTagItem.component);
    const allComponentsToTag = componentsToTag.concat(autoTagConsumerComponents); // check for each one of the components whether it is using an old version

    if (!ignoreNewestVersion && !isSnap) {
      const newestVersionsP = allComponentsToTag.map( /*#__PURE__*/function () {
        var _ref2 = (0, _bluebird().coroutine)(function* (component) {
          if (component.componentFromModel) {
            // otherwise it's a new component, so this check is irrelevant
            const modelComponent = yield scope.getModelComponentIfExist(component.id);
            if (!modelComponent) throw new (_showDoctorError().default)(`component ${component.id} was not found in the model`);
            if (!modelComponent.listVersions().length) return null; // no versions yet, no issues.

            const latest = modelComponent.latest();

            if (latest !== component.version) {
              return {
                componentId: component.id.toStringWithoutVersion(),
                currentVersion: component.version,
                latestVersion: latest
              };
            }
          }

          return null;
        });

        return function (_x17) {
          return _ref2.apply(this, arguments);
        };
      }());
      const newestVersions = yield Promise.all(newestVersionsP);
      const newestVersionsWithoutEmpty = newestVersions.filter(newest => newest);

      if (!RA().isNilOrEmpty(newestVersionsWithoutEmpty)) {
        // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
        throw new (_exceptions().NewerVersionFound)(newestVersionsWithoutEmpty);
      }
    }

    let testsResults = [];

    if (consumer.isLegacy) {
      _logger().default.debugAndAddBreadCrumb('tag-model-components', 'sequentially build all components');

      yield scope.buildMultiple(allComponentsToTag, consumer, false, verbose);

      _logger().default.debug('scope.putMany: sequentially test all components');

      if (!skipTests) {
        const testsResultsP = scope.testMultiple({
          components: allComponentsToTag,
          consumer,
          verbose,
          rejectOnFailure: !force
        });

        try {
          // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
          testsResults = yield testsResultsP;
        } catch (err) {
          // if force is true, ignore the tests and continue
          if (!force) {
            // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
            if (!verbose) throw new (_exceptions().ComponentSpecsFailed)();
            throw err;
          }
        }
      }
    }

    _logger().default.debugAndAddBreadCrumb('tag-model-components', 'sequentially persist all components'); // go through all components and find the future versions for them


    isSnap ? setHashes(allComponentsToTag) : yield setFutureVersions(allComponentsToTag, scope, releaseType, exactVersion, persist);
    setCurrentSchema(allComponentsToTag, consumer); // go through all dependencies and update their versions

    updateDependenciesVersions(allComponentsToTag);
    yield addLogToComponents(componentsToTag, autoTagConsumerComponents, persist, message);

    if (persist) {
      if (!skipTests) addSpecsResultsToComponents(allComponentsToTag, testsResults);
      yield addFlattenedDependenciesToComponents(consumer.scope, allComponentsToTag);
      yield addComponentsToScope(consumer, allComponentsToTag, Boolean(resolveUnmerged));
      validateDirManipulation(allComponentsToTag);
      yield consumer.updateComponentsVersions(allComponentsToTag);
    } else {
      consumer.updateNextVersionOnBitmap(allComponentsToTag, exactVersion, releaseType);
    }

    const publishedPackages = [];

    if (!consumer.isLegacy && persist) {
      const ids = allComponentsToTag.map(consumerComponent => consumerComponent.id);
      const results = yield _bluebird().default.mapSeries(scope.onTag, func => func(ids));
      results.forEach(tagResult => updateComponentsByTagResult(allComponentsToTag, tagResult));
      allComponentsToTag.forEach(comp => {
        var _pkgExt$data;

        const pkgExt = comp.extensions.findCoreExtension('teambit.bit/pkg');
        const publishedPackage = pkgExt === null || pkgExt === void 0 ? void 0 : (_pkgExt$data = pkgExt.data) === null || _pkgExt$data === void 0 ? void 0 : _pkgExt$data.publishedPackage;
        if (publishedPackage) publishedPackages.push(publishedPackage);
      });
      yield _bluebird().default.mapSeries(allComponentsToTag, consumerComponent => scope.sources.enrichSource(consumerComponent));
    }

    if (persist) {
      yield scope.objects.persist();
    }

    return {
      taggedComponents: componentsToTag,
      autoTaggedResults: autoTagData,
      publishedPackages
    };
  });
  return _tagModelComponent.apply(this, arguments);
}

function addComponentsToScope(_x7, _x8, _x9) {
  return _addComponentsToScope.apply(this, arguments);
}

function _addComponentsToScope() {
  _addComponentsToScope = (0, _bluebird().coroutine)(function* (consumer, components, resolveUnmerged) {
    const lane = yield consumer.getCurrentLaneObject();
    yield _bluebird().default.mapSeries(components, /*#__PURE__*/function () {
      var _ref3 = (0, _bluebird().coroutine)(function* (component) {
        yield consumer.scope.sources.addSource({
          source: component,
          consumer,
          lane,
          resolveUnmerged
        });
      });

      return function (_x18) {
        return _ref3.apply(this, arguments);
      };
    }());
  });
  return _addComponentsToScope.apply(this, arguments);
}

function addFlattenedDependenciesToComponents(_x10, _x11) {
  return _addFlattenedDependenciesToComponents.apply(this, arguments);
}

function _addFlattenedDependenciesToComponents() {
  _addFlattenedDependenciesToComponents = (0, _bluebird().coroutine)(function* (scope, components) {
    _loader().default.start('importing missing dependencies...');

    const flattenedDependenciesGetter = new (_getFlattenedDependencies().FlattenedDependenciesGetter)(scope, components);
    yield flattenedDependenciesGetter.populateFlattenedDependencies();

    _loader().default.stop();
  });
  return _addFlattenedDependenciesToComponents.apply(this, arguments);
}

function addSpecsResultsToComponents(components, testsResults) {
  components.forEach(component => {
    const testResult = testsResults.find(result => {
      // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
      return component.id.isEqualWithoutScopeAndVersion(result.componentId);
    });
    component.specsResults = testResult ? testResult.specs : undefined;
  });
}

function addLogToComponents(_x12, _x13, _x14, _x15) {
  return _addLogToComponents.apply(this, arguments);
}

function _addLogToComponents() {
  _addLogToComponents = (0, _bluebird().coroutine)(function* (components, autoTagComps, persist, message) {
    const username = yield globalConfig().get(_constants().CFG_USER_NAME_KEY);
    const email = yield globalConfig().get(_constants().CFG_USER_EMAIL_KEY);

    const getLog = component => {
      var _component$componentM;

      const nextVersion = persist ? (_component$componentM = component.componentMap) === null || _component$componentM === void 0 ? void 0 : _component$componentM.nextVersion : null;
      return {
        username: (nextVersion === null || nextVersion === void 0 ? void 0 : nextVersion.username) || username,
        email: (nextVersion === null || nextVersion === void 0 ? void 0 : nextVersion.email) || email,
        message: (nextVersion === null || nextVersion === void 0 ? void 0 : nextVersion.message) || message,
        date: Date.now().toString()
      };
    };

    components.forEach(component => {
      component.log = getLog(component);
    });
    autoTagComps.forEach(autoTagComp => {
      autoTagComp.log = getLog(autoTagComp);
      autoTagComp.log.message = `${autoTagComp.log.message} (bump dependencies versions)`;
    });
  });
  return _addLogToComponents.apply(this, arguments);
}

function setCurrentSchema(components, consumer) {
  if (consumer.isLegacy) return;
  components.forEach(component => {
    component.schema = _componentSchema().CURRENT_SCHEMA;
  });
}
/**
 * @todo: currently, there is only one function registered to the OnTag, which is the builder.
 * we set the extensions data and artifacts we got from the builder to the consumer-components.
 * however, if there is more than one function registered to the OnTag, the data will be overridden
 * by the last called function. when/if this happen, some kind of merge need to be done between the
 * results.
 */


function updateComponentsByTagResult(components, tagResult) {
  tagResult.forEach(result => {
    const matchingComponent = components.find(c => c.id.isEqual(result.id));

    if (matchingComponent) {
      matchingComponent.extensions = result.extensions;
    }
  });
}