import { ModelComponent, Version } from '../models';
import { Ref, Repository } from '../objects';
declare type VersionInfo = {
    ref: Ref;
    tag?: string;
    version?: Version;
    error?: Error;
};
export declare function getAllVersionsInfo({ modelComponent, repo, throws, versionObjects, startFrom, }: {
    modelComponent: ModelComponent;
    repo?: Repository;
    throws?: boolean;
    versionObjects?: Version[];
    startFrom?: Ref | null;
}): Promise<VersionInfo[]>;
export declare function getAllVersionsObjects(modelComponent: ModelComponent, repo: Repository, throws?: boolean): Promise<Version[]>;
export declare function getAllVersionHashesByVersionsObjects(modelComponent: ModelComponent, versionObjects: Version[], throws?: boolean): Promise<Ref[]>;
export declare function getAllVersionHashes(modelComponent: ModelComponent, repo: Repository, throws?: boolean, startFrom?: Ref | null): Promise<Ref[]>;
export declare function hasVersionByRef(modelComponent: ModelComponent, ref: Ref, repo: Repository, startFrom?: Ref | null): Promise<boolean>;
export {};
