"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.sort");

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _defineProperty2() {
  const data = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

  _defineProperty2 = function () {
    return data;
  };

  return data;
}

function _ramda() {
  const data = require("ramda");

  _ramda = function () {
    return data;
  };

  return data;
}

function semver() {
  const data = _interopRequireWildcard(require("semver"));

  semver = function () {
    return data;
  };

  return data;
}

function _uuid() {
  const data = require("uuid");

  _uuid = function () {
    return data;
  };

  return data;
}

function _featureToggle() {
  const data = require("../../api/consumer/lib/feature-toggle");

  _featureToggle = function () {
    return data;
  };

  return data;
}

function _bitId() {
  const data = _interopRequireDefault(require("../../bit-id/bit-id"));

  _bitId = function () {
    return data;
  };

  return data;
}

function _constants() {
  const data = require("../../constants");

  _constants = function () {
    return data;
  };

  return data;
}

function _component() {
  const data = _interopRequireDefault(require("../../consumer/component"));

  _component = function () {
    return data;
  };

  return data;
}

function _sources() {
  const data = require("../../consumer/component/sources");

  _sources = function () {
    return data;
  };

  return data;
}

function _componentOverrides() {
  const data = _interopRequireDefault(require("../../consumer/config/component-overrides"));

  _componentOverrides = function () {
    return data;
  };

  return data;
}

function _specsResults() {
  const data = _interopRequireDefault(require("../../consumer/specs-results"));

  _specsResults = function () {
    return data;
  };

  return data;
}

function _generalError() {
  const data = _interopRequireDefault(require("../../error/general-error"));

  _generalError = function () {
    return data;
  };

  return data;
}

function _showDoctorError() {
  const data = _interopRequireDefault(require("../../error/show-doctor-error"));

  _showDoctorError = function () {
    return data;
  };

  return data;
}

function _validationError() {
  const data = _interopRequireDefault(require("../../error/validation-error"));

  _validationError = function () {
    return data;
  };

  return data;
}

function _laneId() {
  const data = require("../../lane-id/lane-id");

  _laneId = function () {
    return data;
  };

  return data;
}

function _envFactory() {
  const data = require("../../legacy-extensions/env-factory");

  _envFactory = function () {
    return data;
  };

  return data;
}

function _logger() {
  const data = _interopRequireDefault(require("../../logger/logger"));

  _logger = function () {
    return data;
  };

  return data;
}

function _utils() {
  const data = require("../../utils");

  _utils = function () {
    return data;
  };

  return data;
}

function _findDuplications() {
  const data = _interopRequireDefault(require("../../utils/array/find-duplications"));

  _findDuplications = function () {
    return data;
  };

  return data;
}

function _versionParser() {
  const data = _interopRequireWildcard(require("../../version/version-parser"));

  _versionParser = function () {
    return data;
  };

  return data;
}

function _componentObjects() {
  const data = _interopRequireDefault(require("../component-objects"));

  _componentObjects = function () {
    return data;
  };

  return data;
}

function _getDivergeData() {
  const data = require("../component-ops/get-diverge-data");

  _getDivergeData = function () {
    return data;
  };

  return data;
}

function _traverseVersions() {
  const data = require("../component-ops/traverse-versions");

  _traverseVersions = function () {
    return data;
  };

  return data;
}

function _componentVersion() {
  const data = _interopRequireDefault(require("../component-version"));

  _componentVersion = function () {
    return data;
  };

  return data;
}

function _exceptions() {
  const data = require("../exceptions");

  _exceptions = function () {
    return data;
  };

  return data;
}

function _objects() {
  const data = require("../objects");

  _objects = function () {
    return data;
  };

  return data;
}

function _scopeMeta() {
  const data = _interopRequireDefault(require("./scopeMeta"));

  _scopeMeta = function () {
    return data;
  };

  return data;
}

function _semverHelper() {
  const data = require("../../utils/semver-helper");

  _semverHelper = function () {
    return data;
  };

  return data;
}

const VERSION_ZERO = '0.0.0';
/**
 * we can't rename the class as ModelComponent because old components are already saved in the model
 * with 'Component' in their headers. see object-registrar.types()
 */
// TODO: FIX me .parser
// @ts-ignore

class Component extends _objects().BitObject {
  // doesn't get saved in the scope, used to easier access the remote master head
  // doesn't get saved in the scope, used to easier access the local snap head data
  // doesn't get saved in the scope, used to easier access the remote snap head data
  constructor(props) {
    super();
    (0, _defineProperty2().default)(this, "scope", void 0);
    (0, _defineProperty2().default)(this, "name", void 0);
    (0, _defineProperty2().default)(this, "versions", void 0);
    (0, _defineProperty2().default)(this, "lang", void 0);
    (0, _defineProperty2().default)(this, "deprecated", void 0);
    (0, _defineProperty2().default)(this, "bindingPrefix", void 0);
    (0, _defineProperty2().default)(this, "local", void 0);
    (0, _defineProperty2().default)(this, "state", void 0);
    (0, _defineProperty2().default)(this, "scopesList", void 0);
    (0, _defineProperty2().default)(this, "head", void 0);
    (0, _defineProperty2().default)(this, "remoteHead", void 0);
    (0, _defineProperty2().default)(this, "laneHeadLocal", void 0);
    (0, _defineProperty2().default)(this, "laneHeadRemote", void 0);
    (0, _defineProperty2().default)(this, "divergeData", void 0);
    if (!props.name) throw new TypeError('Model Component constructor expects to get a name parameter');
    this.scope = props.scope || null;
    this.name = props.name;
    this.versions = props.versions || {};
    this.lang = props.lang || _constants().DEFAULT_LANGUAGE;
    this.deprecated = props.deprecated || false;
    this.bindingPrefix = props.bindingPrefix || _constants().DEFAULT_BINDINGS_PREFIX;
    this.local = props.local;
    this.state = props.state || {};
    this.scopesList = props.scopesList || [];
    this.head = props.head;
  } // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!


  get versionArray() {
    return Object.values(this.versions);
  }

  getRef(version) {
    if ((0, _versionParser().isHash)(version)) {
      return new (_objects().Ref)(version);
    }

    return this.versions[version];
  }

  getHeadStr() {
    return this.head ? this.head.toString() : null;
  }

  getHead() {
    return this.head;
  }

  hasHead() {
    return Boolean(this.head);
  }

  setHead(head) {
    if (!(0, _featureToggle().isLaneEnabled)()) return;
    this.head = head;
  }

  listVersions(sort) {
    const versions = Object.keys(this.versions);
    if (!sort) return versions;

    if (sort === 'ASC') {
      return versions.sort(semver().compare);
    }

    return versions.sort(semver().compare).reverse();
  }

  hasVersion(version, repo) {
    var _this = this;

    return (0, _bluebird().coroutine)(function* () {
      if ((0, _versionParser().isTag)(version)) return _this.hasTag(version);
      const allHashes = yield (0, _traverseVersions().getAllVersionHashes)(_this, repo, false);
      return allHashes.some(hash => hash.toString() === version);
    })();
  }

  hasTag(version) {
    return Boolean(this.versions[version]);
  }
  /**
   * add a new remote if it is not there already
   */


  addScopeListItem(scopeListItem) {
    if (!scopeListItem.name || !scopeListItem.url || !scopeListItem.date) {
      throw new TypeError(`model-component.addRemote get an invalid remote. name: ${scopeListItem.name}, url: ${scopeListItem.url}, date: ${scopeListItem.date}`);
    }

    if (!this.scopesList.find(r => r.url === scopeListItem.url)) {
      this.scopesList.push(scopeListItem);
    }
  }

  setDivergeData(repo, throws = true) {
    var _this2 = this;

    return (0, _bluebird().coroutine)(function* () {
      if (!_this2.divergeData) {
        const remoteHead = _this2.laneHeadRemote || _this2.remoteHead || null;
        _this2.divergeData = yield (0, _getDivergeData().getDivergeData)(repo, _this2, remoteHead, throws);
      }
    })();
  }

  getDivergeData() {
    if (!this.divergeData) throw new Error(`getDivergeData() expects divergeData to be populate, please use this.setDivergeData()`);
    return this.divergeData;
  }

  populateLocalAndRemoteHeads(repo, laneId, lane, remoteLaneId = laneId, remoteScopeName = this.scope) {
    var _this3 = this;

    return (0, _bluebird().coroutine)(function* () {
      // @todo: this doesn't take into account a case when local and remote have different names.
      _this3.setLaneHeadLocal(lane);

      if (remoteScopeName) {
        // otherwise, it was never exported, so no remote head
        _this3.laneHeadRemote = yield repo.remoteLanes.getRef(_laneId().RemoteLaneId.from(remoteLaneId.name, remoteScopeName), _this3.toBitId());
      }
    })();
  }

  setLaneHeadLocal(lane) {
    if (lane) {
      this.laneHeadLocal = lane.getComponentHead(this.toBitId());
    }
  }
  /**
   * returns only the versions that exist in both components (regardless whether the hash are the same)
   * e.g. this.component = [0.0.1, 0.0.2, 0.0.3], other component = [0.0.3, 0.0.4]. it returns only [0.0.3].
   * also, in case it is coming from 'bit import', the version must be locally changed.
   * otherwise, it doesn't matter whether the hashes are different.
   */


  _getComparableVersionsObjects(otherComponent, // in case of merging, the otherComponent is the existing component, and "this" is the incoming component
  local) {
    const otherLocalVersion = otherComponent.getLocalVersions();
    const otherComponentVersions = (0, _utils().filterObject)(otherComponent.versions, (val, key) => Object.keys(this.versions).includes(key) && (!local || otherLocalVersion.includes(key)));
    const thisComponentVersions = (0, _utils().filterObject)(this.versions, (val, key) => Object.keys(otherComponentVersions).includes(key) && (!local || otherLocalVersion.includes(key)));
    return {
      thisComponentVersions,
      otherComponentVersions
    };
  }

  compatibleWith(component, local) {
    const {
      thisComponentVersions,
      otherComponentVersions
    } = this._getComparableVersionsObjects(component, local);

    return (0, _ramda().equals)(thisComponentVersions, otherComponentVersions);
  }

  diffWith(component, local) {
    const {
      thisComponentVersions,
      otherComponentVersions
    } = this._getComparableVersionsObjects(component, local);

    return Object.keys(thisComponentVersions).filter(version => thisComponentVersions[version].hash !== otherComponentVersions[version].hash);
  }

  isEmpty() {
    return (0, _utils().empty)(this.versions) && !this.hasHead();
  }

  latest() {
    if (this.isEmpty() && !this.laneHeadLocal) return VERSION_ZERO;
    const head = this.laneHeadLocal || this.getHead();

    if (head) {
      return this.getTagOfRefIfExists(head) || head.toString();
    } // backward compatibility. components created before v15 have master without head
    // @ts-ignore


    return semver().maxSatisfying(this.listVersions(), '*');
  }
  /**
   * a user can be checked out to a lane, in which case, `this.laneHeadLocal` and `this.laneHeadRemote`
   * may be populated.
   * `this.head` may not be populated, e.g. when a component was created on
   * this lane and never got snapped on master.
   * it's impossible that `this.head.isEqual(this.laneHeadLocal)`, because when snapping it's either
   * on master, which goes to this.head OR on a lane, which goes to this.laneHeadLocal.
   */


  latestIncludeRemote(repo) {
    var _this4 = this;

    return (0, _bluebird().coroutine)(function* () {
      const latestLocally = _this4.latest();

      const remoteHead = _this4.laneHeadRemote;
      if (!remoteHead) return latestLocally;

      if (!_this4.laneHeadLocal && !_this4.hasHead()) {
        return remoteHead.toString(); // user never merged the remote version, so remote is the latest
      } // either a user is on master or a lane, check whether the remote is ahead of the local


      const allLocalHashes = yield (0, _traverseVersions().getAllVersionHashes)(_this4, repo, false);
      const isRemoteHeadExistsLocally = allLocalHashes.find(localHash => localHash.isEqual(remoteHead));
      if (isRemoteHeadExistsLocally) return latestLocally; // remote is behind

      return remoteHead.toString(); // remote is ahead
    })();
  }

  latestVersion() {
    if ((0, _utils().empty)(this.versions)) return VERSION_ZERO;
    return (0, _semverHelper().getLatestVersion)(this.listVersions());
  } // @todo: make it readable, it's a mess


  isLatestGreaterThan(version) {
    if (!version) throw TypeError('isLatestGreaterThan expect to get a Version');
    const latest = this.latest();
    if (this.isEmpty()) return false; // in case a snap was created on another lane

    if ((0, _versionParser().isTag)(latest) && (0, _versionParser().isTag)(version)) {
      return semver().gt(latest, version);
    }

    if (latest === version) return false;
    const latestRef = this.getRef(latest);
    if (!latestRef) throw new Error('isLatestGreaterThan, latestRef was not found');
    const latestHash = latestRef.toString();
    const versionRef = this.getRef(version);
    if (!versionRef) return true; // probably a child

    const versionHash = versionRef.toString();
    if (latestHash === versionHash) return false;
    return true;
  }
  /**
   * Return the lateset version which actuall exists in the scope
   * (exists means the object itself exists)
   * This relevant for cases when the component version array has few versions
   * but we don't have all the refs in the object
   *
   * @returns {number}
   * @memberof Component
   */


  latestExisting(repository) {
    if ((0, _utils().empty)(this.versions)) return VERSION_ZERO;
    const versions = this.listVersions('ASC');
    let version = null;
    let versionStr = null;

    while (!version && versions && versions.length) {
      // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
      versionStr = versions.pop(); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      version = this.loadVersionSync(versionStr, repository, false);
    }

    return versionStr || VERSION_ZERO;
  }

  collectLogs(repo) {
    var _this5 = this;

    return (0, _bluebird().coroutine)(function* () {
      const versionsInfo = yield (0, _traverseVersions().getAllVersionsInfo)({
        modelComponent: _this5,
        repo,
        throws: false
      });
      return versionsInfo.reduce((acc, current) => {
        const log = current.version ? current.version.log : {
          message: '<no-data-available>'
        };
        acc[current.tag || current.ref.toString()] = log;
        return acc;
      }, {});
    })();
  }

  collectVersions(repo) {
    return Promise.all(this.listVersions().map(versionNum => {
      // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
      return this.toConsumerComponent(versionNum, this.scope, repo);
    }));
  }

  getTagOfRefIfExists(ref) {
    return Object.keys(this.versions).find(versionRef => this.versions[versionRef].isEqual(ref));
  }

  switchHashesWithTagsIfExist(refs) {
    return refs.map(ref => this.getTagOfRefIfExists(ref) || ref.toString());
  }
  /**
   * if exactVersion is defined, add exact version instead of using the semver mechanism
   */


  getVersionToAdd(releaseType = _constants().DEFAULT_BIT_RELEASE_TYPE, exactVersion) {
    if (exactVersion && this.versions[exactVersion]) {
      throw new (_exceptions().VersionAlreadyExists)(exactVersion, this.id());
    }

    return exactVersion || this.version(releaseType);
  }

  getSnapToAdd() {
    return (0, _utils().sha1)((0, _uuid().v4)());
  }

  addVersion(version, versionToAdd, lane, repo) {
    if (lane) {
      if ((0, _versionParser().isTag)(versionToAdd)) {
        throw new (_generalError().default)('unable to tag when checked out to a lane, please switch to master, merge the lane and then tag again');
      }

      const versionToAddRef = _objects().Ref.from(versionToAdd);

      const existingComponentInLane = lane.getComponentByName(this.toBitId());
      const currentHead = existingComponentInLane && existingComponentInLane.head || this.getHead();

      if (currentHead && !currentHead.isEqual(versionToAddRef)) {
        version.addAsOnlyParent(currentHead);
      }

      lane.addComponent({
        id: this.toBitId(),
        head: versionToAddRef
      });
      repo.add(lane);
      this.laneHeadLocal = versionToAddRef;
      return versionToAdd;
    } // user on master


    const head = this.getHead();

    if (head && head.toString() !== versionToAdd && // happens with auto-snap
    !this.hasTag(versionToAdd)) {
      // happens with auto-tag
      // if this is a tag and this tag exists, the same version was added before with a different hash.
      // adding the current head into the parent will result in a non-exist hash in the parent.
      // if this is a hash and it's the same hash as the current head, adding it as a parent
      // results in a parent and a version has the same hash.
      // @todo: fix it in a more elegant way
      version.addAsOnlyParent(head);
    }

    this.setHead(version.hash());

    if ((0, _versionParser().isTag)(versionToAdd)) {
      this.versions[versionToAdd] = version.hash();
    }

    this.markVersionAsLocal(versionToAdd);
    return versionToAdd;
  }

  version(releaseType = _constants().DEFAULT_BIT_RELEASE_TYPE) {
    const latest = this.latestVersion(); // eslint-disable-next-line @typescript-eslint/no-non-null-assertion

    if (latest) return semver().inc(latest, releaseType);
    return _constants().DEFAULT_BIT_VERSION;
  }

  id() {
    return this.scope ? [this.scope, this.name].join('/') : this.name;
  }

  toBitId() {
    return new (_bitId().default)({
      scope: this.scope,
      name: this.name
    });
  }

  toBitIdWithLatestVersion() {
    return new (_bitId().default)({
      scope: this.scope,
      name: this.name,
      version: this.latest()
    });
  }

  toBitIdWithLatestVersionAllowNull() {
    const id = this.toBitIdWithLatestVersion();
    return id.version === VERSION_ZERO ? id.changeVersion(undefined) : id;
  }

  toObject() {
    function versions(vers) {
      const obj = {};
      (0, _utils().forEach)(vers, (ref, version) => {
        obj[version] = ref.toString();
      });
      return obj;
    }

    const componentObject = {
      name: this.name,
      scope: this.scope,
      versions: versions(this.versions),
      lang: this.lang,
      deprecated: this.deprecated,
      bindingPrefix: this.bindingPrefix,
      remotes: this.scopesList
    }; // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    if (this.local) componentObject.local = this.local; // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    if (!(0, _ramda().isEmpty)(this.state)) componentObject.state = this.state;
    const headStr = this.getHeadStr(); // @ts-ignore

    if (headStr) componentObject.head = headStr;
    return componentObject;
  }

  loadVersion(version, repository) {
    var _this6 = this;

    return (0, _bluebird().coroutine)(function* () {
      const versionRef = _this6.getRef(version);

      if (!versionRef) throw new (_exceptions().VersionNotFound)(version); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      return versionRef.load(repository);
    })();
  }

  loadVersionSync(version, repository, throws = true) {
    const versionRef = this.getRef(version);
    if (!versionRef) throw new (_exceptions().VersionNotFound)(version); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    return versionRef.loadSync(repository, throws);
  }

  collectVersionsObjects(repo, versions) {
    var _this7 = this;

    return (0, _bluebird().coroutine)(function* () {
      const collectRefs = /*#__PURE__*/function () {
        var _ref = (0, _bluebird().coroutine)(function* () {
          const refsCollection = [];

          function addRefs(_x) {
            return _addRefs.apply(this, arguments);
          }

          function _addRefs() {
            _addRefs = (0, _bluebird().coroutine)(function* (object) {
              const refs = object.refs();
              const objs = yield Promise.all(refs.map(ref => ref.load(repo, true)));
              refsCollection.push(...refs);
              yield Promise.all(objs.map(obj => addRefs(obj)));
            });
            return _addRefs.apply(this, arguments);
          }

          const versionsRefs = versions.map(version => _this7.versions[version]);
          refsCollection.push(...versionsRefs);
          const versionsObjects = yield Promise.all(versions.map(version => _this7.versions[version].load(repo)));
          yield Promise.all(versionsObjects.map(versionObject => addRefs(versionObject)));
          return refsCollection;
        });

        return function collectRefs() {
          return _ref.apply(this, arguments);
        };
      }();

      const refs = yield collectRefs();
      return Promise.all(refs.map( /*#__PURE__*/function () {
        var _ref2 = (0, _bluebird().coroutine)(function* (ref) {
          return {
            ref,
            buffer: yield ref.loadRaw(repo)
          };
        });

        return function (_x2) {
          return _ref2.apply(this, arguments);
        };
      }()));
    })();
  }

  collectObjects(repo) {
    var _this8 = this;

    return (0, _bluebird().coroutine)(function* () {
      try {
        const [rawComponent, objects] = yield Promise.all([_this8.asRaw(repo), _this8.collectRaw(repo)]);
        return new (_componentObjects().default)(rawComponent, objects.map(o => o.buffer));
      } catch (err) {
        if (err.code === 'ENOENT') {
          throw new Error(`fatal: an object of "${_this8.id()}" was not found at ${err.path}\nplease try to re-import the component`);
        }

        throw err;
      }
    })();
  }
  /**
   * to delete a version from a component, don't call this method directly. Instead, use sources.removeVersion()
   */


  removeVersion(version) {
    const objectRef = this.getRef(version);
    if (!objectRef) throw new Error(`removeVersion failed finding version ${version}`);
    if (objectRef) delete this.versions[version];
    if (this.state.versions && this.state.versions[version]) delete this.state.versions[version];
    return objectRef || _objects().Ref.from(version);
  }

  toComponentVersion(versionStr) {
    const versionParsed = (0, _versionParser().default)(versionStr);
    const versionNum = versionParsed.latest ? this.latest() : versionParsed.resolve(this.listVersions()); // eslint-disable-next-line @typescript-eslint/no-non-null-assertion

    if ((0, _versionParser().isTag)(versionNum) && !this.hasTag(versionNum)) {
      throw new (_showDoctorError().default)(`the version ${versionNum} does not exist in ${this.listVersions().join('\n')}, versions array`);
    } // eslint-disable-next-line @typescript-eslint/no-non-null-assertion


    return new (_componentVersion().default)(this, versionNum);
  }
  /**
   * convert a ModelComponent of a specific version to ConsumerComponent
   * when it's being called from the Consumer, some manipulation are done on the component, such
   * as stripping the originallySharedDir and adding wrapDir.
   * when it's being called from the Scope, no manipulations are done.
   *
   * @see sources.consumerComponentToVersion() for the opposite action.
   */


  toConsumerComponent(versionStr, scopeName, repository, manipulateDirData) {
    var _this9 = this;

    return (0, _bluebird().coroutine)(function* () {
      _logger().default.debug(`model-component, converting ${_this9.id()}, version: ${versionStr} to ConsumerComponent`);

      const componentVersion = _this9.toComponentVersion(versionStr);

      const version = yield componentVersion.getVersion(repository);

      const loadFileInstance = ClassName => /*#__PURE__*/function () {
        var _ref3 = (0, _bluebird().coroutine)(function* (file) {
          const loadP = file.file.load(repository);
          const content = yield loadP;
          if (!content) throw new (_showDoctorError().default)(`failed loading file ${file.relativePath} from the model`);
          return new ClassName({
            base: '.',
            path: file.relativePath,
            contents: content.contents,
            test: file.test
          });
        });

        return function (_x3) {
          return _ref3.apply(this, arguments);
        };
      }();

      const filesP = version.files ? Promise.all(version.files.map(loadFileInstance(_sources().SourceFile))) : null;
      const distsP = version.dists ? Promise.all(version.dists.map(loadFileInstance(_sources().Dist))) : null; // @todo: this is weird. why the scopeMeta would be taken from the current scope and not he component scope?

      const scopeMetaP = scopeName ? _scopeMeta().default.fromScopeName(scopeName).load(repository) : Promise.resolve();
      const log = version.log || null; // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      const compilerP = (0, _envFactory().makeEnvFromModel)(_constants().COMPILER_ENV_TYPE, version.compiler, repository); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      const testerP = (0, _envFactory().makeEnvFromModel)(_constants().TESTER_ENV_TYPE, version.tester, repository); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      const [files, dists, scopeMeta, compiler, tester] = yield Promise.all([filesP, distsP, scopeMetaP, compilerP, testerP]);
      const extensions = version.extensions.clone();
      const bindingPrefix = _this9.bindingPrefix === 'bit' ? '@bit' : _this9.bindingPrefix; // when generating a new ConsumerComponent out of Version, it is critical to make sure that
      // all objects are cloned and not copied by reference. Otherwise, every time the
      // ConsumerComponent instance is changed, the Version will be changed as well, and since
      // the Version instance is saved in the Repository._cache, the next time a Version instance
      // is retrieved, it'll be different than the first time.
      // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

      const consumerComponent = new (_component().default)({
        name: _this9.name,
        version: componentVersion.version,
        scope: _this9.scope,
        lang: _this9.lang,
        bindingPrefix,
        // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
        mainFile: version.mainFile || null,
        compiler,
        tester,
        dependencies: version.dependencies.getClone(),
        devDependencies: version.devDependencies.getClone(),
        flattenedDependencies: version.flattenedDependencies.clone(),
        flattenedDevDependencies: version.flattenedDevDependencies.clone(),
        packageDependencies: (0, _ramda().clone)(version.packageDependencies),
        devPackageDependencies: (0, _ramda().clone)(version.devPackageDependencies),
        peerPackageDependencies: (0, _ramda().clone)(version.peerPackageDependencies),
        compilerPackageDependencies: (0, _ramda().clone)(version.compilerPackageDependencies),
        testerPackageDependencies: (0, _ramda().clone)(version.testerPackageDependencies),
        files,
        dists,
        mainDistFile: version.mainDistFile,
        docs: version.docs,
        license: scopeMeta ? _sources().License.deserialize(scopeMeta.license) : undefined,
        // todo: make sure we have license in case of local scope
        // @ts-ignore
        specsResults: version.specsResults ? version.specsResults.map(res => _specsResults().default.deserialize(res)) : null,
        log,
        customResolvedPaths: (0, _ramda().clone)(version.customResolvedPaths),
        overrides: _componentOverrides().default.loadFromScope(version.overrides),
        packageJsonChangedProps: (0, _ramda().clone)(version.packageJsonChangedProps),
        deprecated: _this9.deprecated,
        scopesList: (0, _ramda().clone)(_this9.scopesList),
        schema: version.schema,
        extensions
      });

      if (manipulateDirData) {
        consumerComponent.stripOriginallySharedDir(manipulateDirData);
        consumerComponent.addWrapperDir(manipulateDirData);
      }

      return consumerComponent;
    })();
  } // @todo: make sure it doesn't have the same ref twice, once as a version and once as a head


  refs() {
    const versions = Object.values(this.versions);
    if (this.head) versions.push(this.head);
    return versions;
  }

  replaceRef(oldRef, newRef) {
    const replace = (value, key) => {
      if (value === oldRef.hash) {
        // @ts-ignore
        this.versions[key] = newRef.hash;
      }
    };

    (0, _ramda().forEachObjIndexed)(replace, this.versions);
  }

  validateBeforePersisting(componentStr) {
    _logger().default.silly(`validating component object: ${this.hash().hash} ${this.id()}`);

    const component = Component.parse(componentStr);
    component.validate();
  }

  toBuffer(pretty) {
    const args = (0, _utils().getStringifyArgs)(pretty);
    const obj = this.toObject();
    const str = JSON.stringify(obj, ...args);
    if (this.validateBeforePersist) this.validateBeforePersisting(str);
    return Buffer.from(str);
  }
  /**
   * Clear data that is relevant only for the local scope and should not be moved to the remote scope
   */


  clearStateData() {
    this.local = false; // backward compatibility for components created before 0.12.6

    this.state = {};
  }

  markVersionAsLocal(version) {
    if (!this.state.versions) this.state = {
      versions: {}
    }; // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    if (!this.state.versions[version]) this.state.versions[version] = {}; // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    this.state.versions[version].local = true;
  }

  getLocalVersions() {
    if ((0, _ramda().isEmpty)(this.state) || (0, _ramda().isEmpty)(this.state.versions)) return []; // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
    // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    return Object.keys(this.state.versions).filter(version => this.state.versions[version].local);
  }

  getLocalTagsOrHashes() {
    const localVersions = this.getLocalVersions();
    if (!this.divergeData) return localVersions;
    const divergeData = this.getDivergeData();
    const localHashes = divergeData.snapsOnLocalOnly;
    if (!localHashes.length) return localVersions; // @todo: this doesn't make sense when creating a new lane locally.
    // the laneHeadRemote is not set. it needs to be compare to the head

    if (!this.laneHeadRemote && this.scope) return localVersions; // backward compatibility of components tagged before v15

    return this.switchHashesWithTagsIfExist(localHashes).reverse(); // reverse to get the older first
  }

  isLocallyChanged(lane, repo) {
    var _this10 = this;

    return (0, _bluebird().coroutine)(function* () {
      if (lane) {
        if (!repo) throw new Error('isLocallyChanged expects to get repo when lane was provided');
        yield _this10.populateLocalAndRemoteHeads(repo, lane.toLaneId(), lane);
        yield _this10.setDivergeData(repo);
        return _this10.getDivergeData().isLocalAhead();
      } // when on master, no need to traverse the parents because local snaps/tags are saved in the
      // component object and retrieved by `this.getLocalVersions()`.


      if (_this10.local) return true; // backward compatibility for components created before 0.12.6

      const localVersions = _this10.getLocalVersions();

      if (localVersions.length) return true;
      if (_this10.laneHeadLocal && !_this10.laneHeadRemote) return true;
      return false;
    })();
  }

  static parse(contents) {
    const rawComponent = JSON.parse(contents);
    return Component.from({
      name: rawComponent.box ? `${rawComponent.box}/${rawComponent.name}` : rawComponent.name,
      scope: rawComponent.scope,
      versions: (0, _utils().mapObject)(rawComponent.versions, val => _objects().Ref.from(val)),
      lang: rawComponent.lang,
      deprecated: rawComponent.deprecated,
      bindingPrefix: rawComponent.bindingPrefix,
      local: rawComponent.local,
      state: rawComponent.state,
      scopesList: rawComponent.remotes,
      head: rawComponent.head ? _objects().Ref.from(rawComponent.head) : undefined
    });
  }

  static from(props) {
    return new Component(props);
  }

  static fromBitId(bitId) {
    if (bitId.box) throw new Error('component.fromBitId, bitId should not have the "box" property populated'); // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!

    return new Component({
      name: bitId.name,
      scope: bitId.scope
    });
  }

  validate() {
    const message = `unable to save Component object "${this.id()}"`;
    if (!this.name) throw new (_generalError().default)(`${message} the name is missing`);

    if (this.state && this.state.versions) {
      Object.keys(this.state.versions).forEach(version => {
        if ((0, _versionParser().isTag)(version) && !this.hasTag(version)) {
          throw new (_validationError().default)(`${message}, the version ${version} is marked as staged but is not available`);
        }
      });
    }

    const hashDuplications = (0, _findDuplications().default)(this.versionArray.map(v => v.toString()));

    if (hashDuplications.length) {
      throw new (_validationError().default)(`${message}, the following hash(es) are duplicated ${hashDuplications.join(', ')}`);
    }
  }

}

exports.default = Component;