"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _chai() {
  const data = require("chai");

  _chai = function () {
    return data;
  };

  return data;
}

function _ramda() {
  const data = _interopRequireDefault(require("ramda"));

  _ramda = function () {
    return data;
  };

  return data;
}

function _componentModelObject() {
  const data = _interopRequireDefault(require("../../../fixtures/component-model-object.json"));

  _componentModelObject = function () {
    return data;
  };

  return data;
}

function _modelComponent() {
  const data = _interopRequireDefault(require("./model-component"));

  _modelComponent = function () {
    return data;
  };

  return data;
}

const getModelComponentFixture = () => {
  return _ramda().default.clone(_componentModelObject().default);
};

const getModelComponent = obj => {
  return _modelComponent().default.parse(JSON.stringify(obj));
};

describe('ModelComponent', () => {
  describe('validate', () => {
    let validateFunc;
    describe('duplicate hashes', () => {
      let modelComponent;
      before(() => {
        const fixture = getModelComponentFixture();
        fixture.versions['0.0.2'] = fixture.versions['0.0.1'];
        modelComponent = getModelComponent(fixture);

        validateFunc = () => modelComponent.validate();
      });
      it('should throw an error', () => {
        (0, _chai().expect)(validateFunc).to.throw('the following hash(es) are duplicated');
      });
    });
  });
});