"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BitObjectList = void 0;

function _models() {
  const data = require("../models");

  _models = function () {
    return data;
  };

  return data;
}

class BitObjectList {
  constructor(objects) {
    this.objects = objects;
  }

  getComponents() {
    return this.objects.filter(object => object instanceof _models().ModelComponent);
  }

  getVersions() {
    return this.objects.filter(object => object instanceof _models().Version);
  }

  getLanes() {
    return this.objects.filter(object => object instanceof _models().Lane);
  }

  getAll() {
    return this.objects;
  }

  getAllExceptComponentsAndLanes() {
    return this.objects.filter(object => !(object instanceof _models().ModelComponent) && !(object instanceof _models().Lane));
  }

}

exports.BitObjectList = BitObjectList;