/// <reference types="node" />
import { BitObjectList } from './bit-object-list';
import Ref from './ref';
export declare type ObjectItem = {
    ref: Ref;
    buffer: Buffer;
    type?: string;
};
export declare const FETCH_FORMAT_OBJECT_LIST = "ObjectList";
export declare class ObjectList {
    objects: ObjectItem[];
    constructor(objects?: ObjectItem[]);
    count(): number;
    static mergeMultipleInstances(ObjectLists: ObjectList[]): ObjectList;
    static fromJsonString(jsonStr: string): ObjectList;
    toJsonString(): string;
    toTar(): NodeJS.ReadableStream;
    static fromTar(packStream: NodeJS.ReadableStream): Promise<ObjectList>;
    addIfNotExist(objectItems: ObjectItem[]): void;
    toBitObjects(): Promise<BitObjectList>;
}
