/// <reference types="node" />
import { ObjectItem } from './object-list';
import Ref from './ref';
import Repository from './repository';
export default class BitObject {
    validateBeforePersist: boolean;
    id(): string | Buffer;
    toBuffer(pretty?: boolean): Buffer;
    refs(): Ref[];
    getHeader(buffer: Buffer): string;
    collectRefs(repo: Repository): Promise<Ref[]>;
    collectRaw(repo: Repository): Promise<ObjectItem[]>;
    asRaw(repo: Repository): Promise<Buffer>;
    collect(repo: Repository): BitObject[];
    hash(): Ref;
    compress(): Promise<Buffer>;
    serialize(): Buffer;
    static parseObject(fileContents: Buffer): Promise<BitObject>;
    static parseSync(fileContents: Buffer): BitObject;
    static makeHash(str: string | Buffer): string;
}
