"use strict";

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _exceptions() {
  const data = require("./exceptions");

  _exceptions = function () {
    return data;
  };

  return data;
}

class AbortablePromise extends Promise {
  constructor(promiseFn, abortFn) {
    super(promiseFn);
    this.abortFn = abortFn;
  }

  abort() {
    if (this.abortFn) return this.abortFn();
    throw new (_exceptions().MissingAbortFn)();
  }

}

exports.default = AbortablePromise;