"use strict";

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.promise");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = filterAsync;

/**
 * Array.filter is synchronous and therefore does not support Promises.
 * This one works with promises.
 * Taken from https://stackoverflow.com/questions/33355528/filtering-an-array-with-a-function-that-returns-a-promise
 */
function filterAsync(array, filter) {
  // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
  return Promise.all(array.map(entry => filter(entry))).then(results => array.filter(() => results.shift()));
}