"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

function _chai() {
  const data = require("chai");

  _chai = function () {
    return data;
  };

  return data;
}

function _findDuplications() {
  const data = _interopRequireDefault(require("./find-duplications"));

  _findDuplications = function () {
    return data;
  };

  return data;
}

describe('findDuplications', () => {
  it('should find duplications in an array of strings', () => {
    const arr = ['a', 'b', 'c', 'a'];
    const result = (0, _findDuplications().default)(arr);
    (0, _chai().expect)(result).to.deep.equal(['a']);
  });
  it('should not find duplications if there are not any', () => {
    const arr = ['a', 'b', 'c', 'd'];
    const result = (0, _findDuplications().default)(arr);
    (0, _chai().expect)(result).to.deep.equal([]);
  });
  it('should find duplications in an array of numbers', () => {
    const arr = [1, 2, 2, 2, 3, 4, 5, 5, 6];
    const result = (0, _findDuplications().default)(arr);
    (0, _chai().expect)(result).to.deep.equal([2, 5]);
  });
});