"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getNodeModulesPathOfComponent;

function path() {
  const data = _interopRequireWildcard(require("path"));

  path = function () {
    return data;
  };

  return data;
}

function _generalError() {
  const data = _interopRequireDefault(require("../../error/general-error"));

  _generalError = function () {
    return data;
  };

  return data;
}

function _componentIdToPackageName() {
  const data = _interopRequireDefault(require("./component-id-to-package-name"));

  _componentIdToPackageName = function () {
    return data;
  };

  return data;
}

function getNodeModulesPathOfComponent({
  bindingPrefix,
  id,
  allowNonScope = false,
  defaultScope,
  // if an id doesn't have a scope, use defaultScope if exists. applies only when allowNonScope is true
  extensions,
  isDependency = false
}) {
  if (!id.scope && !allowNonScope) {
    throw new (_generalError().default)(`Failed creating a path in node_modules for ${id.toString()}, as it does not have a scope yet`);
  }

  const packageName = (0, _componentIdToPackageName().default)({
    id,
    bindingPrefix,
    defaultScope,
    withPrefix: undefined,
    extensions,
    isDependency
  });
  return path().join('node_modules', packageName);
}