"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es.string.replace");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replacePlaceHolderWithComponentValue = replacePlaceHolderWithComponentValue;
exports.replacePlaceHolderForPackageName = replacePlaceHolderForPackageName;

function _path() {
  const data = _interopRequireDefault(require("path"));

  _path = function () {
    return data;
  };

  return data;
}

function _stringFormat() {
  const data = _interopRequireDefault(require("string-format"));

  _stringFormat = function () {
    return data;
  };

  return data;
}

/**
 * search for placeholders, such as {main}, {name} in a template and replace them with the values
 * from the component with some manipulations
 */
function replacePlaceHolderWithComponentValue(component, template) {
  if (typeof template !== 'string') return template;
  const values = {
    main: () => getMainFileWithoutExtension(component.mainFile),
    name: () => replaceSlashesWithDots(component.name),
    scope: () => component.scope
  };
  return (0, _stringFormat().default)(template, values);
}

function replacePlaceHolderForPackageName({
  name,
  scope
}, template) {
  const values = {
    name: () => replaceSlashesWithDots(name),
    scope: () => scope
  };
  return (0, _stringFormat().default)(template, values);
}

function getMainFileWithoutExtension(mainFile) {
  return mainFile.replace(new RegExp(`${_path().default.extname(mainFile)}$`), ''); // makes sure it's the last occurrence
}

function replaceSlashesWithDots(name) {
  const allSlashes = new RegExp('/', 'g');
  return name.replace(allSlashes, '.');
}