"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = currentDirName;

function path() {
  const data = _interopRequireWildcard(require("path"));

  path = function () {
    return data;
  };

  return data;
}

/**
 * get the current working dir name.
 * @name currentDirName
 * @returns {string} current working dir name
 * @example
 * ```js
 *  currentDirName() // => 'bit'
 * ```
 */
function currentDirName() {
  const currentDir = process.cwd();
  return path().basename(currentDir);
}