"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = empty;

function _hasOwnProperty() {
  const data = _interopRequireDefault(require("./has-own-property"));

  _hasOwnProperty = function () {
    return data;
  };

  return data;
}

/**
 * determines whether `obj` reference is empty (empty array, empty object and/or falsy values)
 * @name empty
 * @param {*} name
 * @returns {boolean}
 * @example
 * ```js
 *  empty([]) // => true
 *  empty({}) // => true
 *  empty(1) // => false
 *  empty('') // => false
 *  empty('foo') // => true
 * ```
 */
function empty(obj) {
  for (const n in obj) if ((0, _hasOwnProperty().default)(obj, n) && obj[n]) return false; // eslint-disable-line


  return true;
}