"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.requireWithUndefinedGlobalWindow = requireWithUndefinedGlobalWindow;

/**
 * this is needed since the upgrade of ink to v3. this version added the react-dev-tools, which
 * sets the global window. other packages, e.g. Vue, check whether it's browser by checking the
 * global.window.
 */
function requireWithUndefinedGlobalWindow(pkgName) {
  const previousGlobalWindow = global.window; // @ts-ignore

  global.window = undefined; // eslint-disable-next-line import/no-dynamic-require, global-require

  const pkg = require(pkgName);

  global.window = previousGlobalWindow;
  return pkg;
}